% half_prof: Main routine for the gated analysis 
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
% Main analysis routine, NOT documented yet, sorry
%function half_prof 
function half_prof 
t_start(2)

global a_addr a_adstart a_adend a_control ad_lpg ad_coeff ad_range ADDR_SHIFT 
global d_data d_var1 d_var2 d_time p_rep p_dtau ch_el dp_comp di_fit dp_fit
global lpg_ND lpg_lag lpg_womscaled lpg_bac lpg_cal lpg_background
global a_priori a_priorierror p_ND
global r_range r_status r_ind g_ind
global pldfvv p_D0 p_N0 p_T0 p_om k_radar k_radar0
global iterMonitor

r_ind=0;
for g_ind=1:length(a_adstart)
  r_ind=r_ind+1;
  % ADDR_SHIFT is added to result memory addresses 
  % in order to transfer from radar indexing to Matlab indexing
  addr=a_addr(a_adstart(g_ind):a_adend(g_ind)); 
  lpgs=ad_lpg(addr+ADDR_SHIFT); % These are the lag profile groups of the data points
    
  f_womega=[real(lpg_womscaled(lpgs,:));imag(lpg_womscaled(lpgs,:))];
  p_coeffg=[ad_coeff(addr+ADDR_SHIFT),ad_coeff(addr+ADDR_SHIFT)]';

  signal_acf=[real(d_data(addr+ADDR_SHIFT));imag(d_data(addr+ADDR_SHIFT))];  
  measurement=[signal_acf;col(a_priori(g_ind,1:5))];

  % Take starting point from the a priori model, temperature values are taken from
  % the previous gate (if previous fit was successful and gate above the present one).  
  aa=a_priori(g_ind,:); 
  if r_ind>1, if mean(ad_range(addr+ADDR_SHIFT))>=r_range(r_ind-1) & r_status(r_ind-1)==0,
		  if all(result(1:3) > [2e10/p_N0, 100/p_T0, 0.5]); % These could be good starting points
      aa(2:3)=result(2:3); aa(1)=aa(1)*(1+result(3))/(1+a_priori(r_ind,3));
				end
  end, end

  if a_control(4)==1, % Using variance estimates calculated from data
      signal_var=real([d_var1(addr+ADDR_SHIFT)+d_var2(addr+ADDR_SHIFT);...
                       d_var2(addr+ADDR_SHIFT)-d_var1(addr+ADDR_SHIFT)])/2;  
      ind=find(signal_var==0); % Assume here diagonal variance
      signal_var(ind)=eps*ones(size(ind));
      diag_var=signal_var;
      variance=[signal_var; (a_priorierror(g_ind,1:5)').^2];
  elseif a_control(4)>=2  % calculating variance estimates from ambiguity functions
      % The variance scaling is calculated from the integration time here
      % In fact, it should be based on the loop counter value stored to the data dump
      Int_time=(d_time(2,3:6)-d_time(1,3:6))*[24*3600; 3600; 60 ; 1];
      if Int_time<0, Int_time=Int_time+24*3600; end
      Var_scale=(p_rep*p_dtau*1e-6/Int_time);

      lpgbac=lpg_bac(diff_val(lpg_cal(lpgs)));
						ind=find(lpg_lag(lpgbac)==0);
      Tback=mean(lpg_background(lpgbac(ind)));

						if a_control(4)==2 % variances only
        [covRe,covIm]=adgr_var(addr,Tback,aa);
        ND2=p_ND*(lpg_ND(lpgs).^2);
        signal_var=[covRe./ND2,covIm./ND2]'.*Var_scale;
        % The variance for zero lag imaginary parts is zero. These must be corrected
		      % to some non-zero value in order the program to work.
        ind=find(signal_var==0); % Assume here diagonal variance
      		signal_var(ind)=eps*ones(size(ind));
        diag_var=[covRe./ND2,covIm./ND2]'.*Var_scale;
        variance=[signal_var; (a_priorierror(g_ind,1:5)').^2];
						elseif a_control(4)==3 % covariances as well
        [covRe,covIm]=adgr_covar(addr,addr,Tback,aa);
        ND2=p_ND*(lpg_ND(lpgs)'*lpg_ND(lpgs));
        signal_var=[covRe./ND2,zeros(size(covRe));...
                    zeros(size(covRe)),covIm./ND2]'.*Var_scale;
        diag_var=diag(signal_var);
        % The variance for zero lag imaginary parts is zero. These must be corrected
      		% to some non-zero value in order the program to work.
       ind=find(diag_var==0); mindiag=min(diag_var(diag_var>0));
       for ii=ind'; signal_var(ii,ii)=mindiag; end
       [M,N]=size(signal_var);
       variance=[signal_var, zeros(M,5);zeros(5,N),diag((a_priorierror(g_ind,1:5)').^2)];
      end
  end
		reind=1:length(addr); % Real parts and diagonal only needed in altitude calculation!
  r_range(r_ind)=sum(ad_range(addr+ADDR_SHIFT)./diag_var(reind)')/sum(1 ./diag_var(reind));

  ch=1;  kd2=k_radar(ch)^2*p_D0^2; Fscale=k_radar0(ch)/k_radar(ch); % hyi hyi
  [small_f_womega,small_p_om]=find_om_grid(aa,p_coeffg,f_womega,kd2,Fscale*p_om,pldfvv);
		
  errorlim=a_control(1); status=0;
  if errorlim>0 & errorlim<10000 % To prevent unnecessary error estimation
    % Check if the error of Ne larger than given limit when the fit is started
    [error,correl,alpha]=error_estimate(aa,variance,kd2,p_coeffg,...
				                                          small_f_womega,small_p_om,pldfvv);
    if error(1)/aa(1) > errorlim, result=aa; chi2=inf; status=2 ; end  % No fit done
  end
  if status==0, % Now proceed to the fitting routine
    tol=a_control(2); maxiter=a_control(3); 
    t_start(3),
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if a_control(4)<=2
      [result,chi2,iter,alpha]=mrqmndiag(aa,measurement,variance,tol,maxiter,...
              kd2,p_coeffg,small_f_womega,small_p_om,pldfvv);
    else
      [result,chi2,iter,alpha]=mrqmn(aa,measurement,variance,tol,maxiter,...
              kd2,p_coeffg,small_f_womega,small_p_om,pldfvv);
	end
	iterMonitor = iter;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    t_stop(3),
    status=(iter>=maxiter);
  end
  % Forward only the variances (not covariances) to store_results
  if min(size(variance))>1; variance=diag(variance); end
  store_results(aa,measurement,variance,result(1:5),alpha,chi2,status,...
		                       kd2,p_coeffg,small_f_womega,small_p_om,pldfvv);
end

t_stop(2)
