@(#)Master_AnalyseGUP0.m	1.1 98/02/25
%
% GUISDAP v1.60   
%
% GUP0 analysis 
%
% Set start and end times before running.
%
% Analysis takes data from /opt/gup0 (and sub-directories) and puts the
% results in /data/gup0/analysis.  Data are post integrated for one
% minute, pulses are analysed separately and the whole height range is
% covered.  The order of the pulses is inverted so that the results for
% the last pulse transmitted (lowest range) come first (makes the plotting
% look better).
%
% Instructions for merging all frequencies and restricting the height range
% are included as comments.
%
% July 1997
%

% Set up path variables required

path_GUP='/opt/guisdap/';
path_exps='/opt/guisdap/exps/';

path('/opt/guisdap/m152gr',path);
path('/opt/guisdap/m160',path);
path('/opt/guisdap/m160ESR',path);
path('/opt/guisdap/mex152',path);
path('/opt/guisdap/local',path);
path('/opt/guisdap/para',path);

start_GUP

path_GUP='/opt/guisdap/';
path_exps='/opt/guisdap/exps/';

% Experiment name and site and paths
name_expr='gup0';     
name_site='L';

global data_path_parent
data_path_parent='/data/gup0/';

result_path='/data/gup0/analysis/';   % result folder

% Time interval to analyze in form
%               Year Month Day Hour Min Sec
analysis_start=[1997   7  19  01 00  00];
analysis_end=  [1997   7  19  23 00  00];

% postintegration strategy defines how many seconds first to skip and integrate.
% the vectors are used cyclically
analysis_integr=[60];
analysis_skip  =[  0];  % Optional, assumed to be zero if not specified

% The range gate definitions for whole range
 rangeLP=[102:3:150 150:12:330 330:36:690 690:72:1000];lenLP=length(rangeLP);
% The range gate definitions for reduced range
%rangeLP=[102:3:150 150:12:330 330:36:600];lenLP=length(rangeLP);
 
% Analyze each pulse separately, combining the two halfs of IPP together
 analysis_range=[rangeLP rangeLP rangeLP rangeLP];
 analysis_code=[kron([68 57 24 13],ones(1,lenLP))];
% Analyze all pulses together
%analysis_range=[rangeLP];
%analysis_code=[kron([13245768],ones(1,lenLP))];

analysis_control=[.5 .01 10 1];
display_figures=[0 0 0 0];
an_start
