function [x,y,z,r,theta,phi] = csconv(x,y,z,r,theta,phi,imode)
%
%     converted from subroutine csconv()
%
%     jmh - 11/79  ans fortran 66
%
%     csconv converts between cartesian coordinates x,y,z and spherical
%     coordinates r,theta,phi. if imode=1, (x,y,z) -> (r,theta,phi).
%     if imode=2, (r,theta,phi) -> (x,y,z). theta and phi are in
%     degrees.
%

      dtr   = 0.0174532925199d0;
      rlmin = 1.d-38;

      if imode == 2

         t = dtr*theta;
         p = dtr*phi;
         ct = cos(t);
         st = sin(t);
         cp = cos(p);
         sp = sin(p);
         x = r*st*cp;
         y = r*st*sp;
         z = r*ct;
         
      else

         rho2 = x*x + y*y;
         r = sqrt(rho2+z*z);
         if sign(z) >= 0;
            theta = atan2(sqrt(rho2),1.d0*max(abs(z),rlmin))/dtr;
         else
            theta = atan2(sqrt(rho2),-1.d0*max(abs(z),rlmin))/dtr;
         end
         if sign(x) >= 0
            phi = atan2(y,1.d0*max(abs(x),rlmin))/dtr;
         else
            phi = atan2(y,-1.d0*max(abs(x),rlmin))/dtr;
         end;
         
      end;
      