function [list,msg]= getfilelist(dirpath) %{

%[LIST,MSG]= GETFILELIST(DIRPATH)

% 21-Jul-1998 Jm
%====================================================================

    list = [];
    msg = '';

    if nargin ~= 1
        error('Wrong number of input arguments');
        return;        
    end
                
    if isempty(dirpath)
        msg = 'Empty directory path';
        return
    end  

    if exist(dirpath,'dir') == 7
        dpath = fullfile(dirpath,filesep);
        template = [dpath,'*.mat'];
    else
        msg = [dirpath ' is not a directory'];
        return
    end
                
    dirlist = dir(template);
    if isempty(dirlist)
        msg = ['No mat files in ' dirpath];
        return;
    end    

    dirlen = length(dirlist);
    list = zeros(1,dirlen);
    k = 0;
    for i = 1:dirlen
        name = dirlist(i).name;
        a = sscanf(name,'%d');
        if ~isempty(a)
            k = k+1;
            list(k) = a;
        end    
    end

    if k < dirlen        
        if k == 0
            msg = [dirpath ' - No valid mat files'];
            return;
        else            
            list = list(1:k);
        end    
    end
    list = sort(list);
%}getfilelist
