function [s, dpath]= isdirectory(path)

% ISDIRECTORY Check if a given path is a directory.
% [ANS,DPATH]= ISDIRECTORY(PATH)
% * Return ANS=1 if PATH is an existing directory. 
% * Return 0 otherwise.                                 
% * Terminate the returned path DPATH with the filesep character.

% Apr 01, 1997 Jm, for Matlab 5.
%----------------------------------------------------------------

separator= filesep;

s= 0; dpath='';

if nargin ~= 1
    error('Invalid number of input arguments');
end   

if ~isstr(path)
    error('Invalid input -- string expected')
end   

if isempty(path)
    disp('Warning: Empty pathname')
    return
end  

len= length(path);

if len == 1 & path == separator
    s= 1;
    dpath= path;
    return;
end   

if path(len) == separator
    path(len)= [];
end    

if exist(path,'dir') == 7
    dpath= [path separator];
    s= 1;
end    
   
return   
