% analysis_batch_inputs.m
% mainland analysis for GUISDAP v1.65   
% 20011111 bi

% ------------------------------------------------------------------------------
% analysis batch inputs file
% ------------------------------------------------------------------------------

  disp(sprintf('analysis_batch_inputs: example file'));

% ------------------------------------------------------------------------------
% name_expr
  name_expr = 'cp1lt@uhf';
  name_expr = 'tau2t@uhf';
  name_expr = 'tau2at_cp1@uhf';
  name_expr = 'cp4bv@vhf1';
  name_expr = 'cp4bv@vhf2';
  name_expr = 'cp7hv@vhf0';
  name_expr = 'tau1@vhf1';
  name_expr = 'tau1@vhf2';
  name_expr = 'tau1v@vhf1';
  name_expr = 'tau1v@vhf2';
  name_expr = 'tau1av@vhf1';
  name_expr = 'tau1av@vhf2';
  name_expr = 'tau1avsingle@vhf0';
  name_expr = 'tau1_singel_v@vhf0';  % non-2001-convention name
  name_expr = 'gup0@32m';
  name_expr = 'gup0@42m';
  name_expr = 'gup1@32m';
  name_expr = 'gup1@42m';
  name_expr = 'gup2@32m';
  name_expr = 'gup2@42m';
  name_expr = 'gup3@32m';
  name_expr = 'gup3@42m';
  name_expr = 'tau0@32m';
  name_expr = 'tau0@42m';
%
  name_expr = 'cp1lt@uhf';
  name_expr = 'tau1avsingle@vhf0';

% ------------------------------------------------------------------------------
% codes_selected: ac, lp, or aclp (applies only to cp1lt)
  codes_selected = 'aclp';
  codes_selected = 'ac';
  codes_selected = 'lp';

% ------------------------------------------------------------------------------
% rawdataroot: convention is /data1 for uhf and /data2 for vhf
  rawdataroot = '/data0';
  rawdataroot = '/data1';
  rawdataroot = '/data2';
  rawdataroot = '/data3';
%
  rawdataroot = '/data1';
  rawdataroot = '/data2';

% ------------------------------------------------------------------------------
% start and end times
  analysis_start = [2001 0 0 0 0 0];  % y m d h m s
  analysis_end   = [2001 0 0 0 0 0];  % y m d h m s
%
  analysis_start = [2001 03 09 0 0 0];  % y m d h m s
  analysis_end   = [2001 03 11 0 0 0];  % y m d h m s
%
  analysis_start = [2001 11 11 9 0 0];  % y m d h m s
  analysis_end   = [2001 11 11 23 0 0];  % y m d h m s

% ------------------------------------------------------------------------------
% integration and skip times
  analysis_integr = [60];  % integration time in s
  analysis_skip   = [ 0];  % optional, assumed to be zero if not specified
  
% ------------------------------------------------------------------------------
% integration mode
  realtime = 1;  % 1 = real time integration
  realtime = 0;  % 1 = real time integration

% ------------------------------------------------------------------------------
% analysis control parameters
%   analysis_control(1) : if error of Ne exceeds this, no fit done
%   analysis_control(2) : iteration stopped, when step below this
%   analysis_control(3) : max number of iterations
%   analysis_control(4) : variance calculation; =1 for calculated, 2 for theoretical.
%   analysis_control(4) : variance calculation; =1 for calculated, 2 for theoretical.
  analysis_control = [.5 .01 100 1];

% ------------------------------------------------------------------------------
% display control flags
%   display_figures(1) : data dump shown
%   display_figures(2) : raw electron density shown
%   display_figures(3) : data and fitted curve for each fit shown
%   display_figures(4) : results shown after each dump
% display_figures = input( 'Select graphics output in the form [0 0 0 1]: ');
  display_figures = [0 0 0 1];
  display_figures = [1 1 1 1];

% ------------------------------------------------------------------------------
% uncomment the next line for loads of diagnostics from integrate
% trace_level = 3;

% ------------------------------------------------------------------------------
