% analysis_commonrt_inputs.m
% mainland analysis for GUISDAP v1.65   


% globals
% global codes_selected analysis_integr trace_level


  disp(sprintf('        Welcome to EISCAT common program analysis.'));

  disp(sprintf(' '));
  disp(sprintf('        Common program analysis options: '));
  disp(sprintf(' '));
% disp(sprintf('            1    tau2at_cp1 '));
% disp(sprintf('             2    tau3at_cp4w '));
  disp(sprintf('              31   cp1lt / long pulse '));
  disp(sprintf('               32   cp1lt / alternating code '));
% disp(sprintf('                4    arc-u '));
  disp(sprintf(' '));
  disp(sprintf('            5    tau1avsingle '));
  disp(sprintf('             51   tau1av / beam 1 '));
  disp(sprintf('              52   tau1av / beam 2 '));
  disp(sprintf('               61   cp4bv / beam 1 '));
  disp(sprintf('                62   cp4bv / beam 2 '));
  disp(sprintf('                 7    cp7hv '));
% disp(sprintf('                  8    arc-v '));
  disp(sprintf(' '));
  disp(sprintf('        When running a program with two options, '));
  disp(sprintf('        please start a separate analysis for each. '));
  disp(sprintf(' '));
  disp(sprintf('        If the analysis stops for any reason, '));
  disp(sprintf('        or if the stop time is extended, please '));
  disp(sprintf('        start again prior to the last analyzed time. '));

  disp(sprintf(' '));
  cpselect = input( '        Please enter your selection: ');

  if cpselect == 1
    disp(sprintf('analysis_commonrt_inputs: ERROR: invalid choice (%d), please start over.',cpselect));
    exit
    name_expr = 'tau2at_cp1@uhf';
    rawdataroot = '/data1';

  elseif cpselect == 2
    disp(sprintf('analysis_commonrt_inputs: ERROR: invalid choice (%d), please start over.',cpselect));
    exit
    name_expr = 'tau3at_cp4w@uhf';
    rawdataroot = '/data1';

  elseif cpselect == 31
    name_expr = 'cp1lt@uhf';
    codes_selected = 'lp';  % applies only to cp1lt
    rawdataroot = '/data1';

  elseif cpselect == 32
    name_expr = 'cp1lt@uhf';
    codes_selected = 'ac';  % applies only to cp1lt
    rawdataroot = '/data1';

  elseif cpselect == 5
    name_expr = 'tau1avsingle@vhf0';
    rawdataroot = '/data2';

  elseif cpselect == 51
    name_expr = 'tau1av@vhf1';
    rawdataroot = '/data2';

  elseif cpselect == 52
    name_expr = 'tau1av@vhf2';
    rawdataroot = '/data2';

  elseif cpselect == 61
    name_expr = 'cp4bv@vhf1';
    rawdataroot = '/data2';

  elseif cpselect == 62
    name_expr = 'cp4bv@vhf2';
    rawdataroot = '/data2';

  elseif cpselect == 7
    name_expr = 'cp7hv@vhf0';
    rawdataroot = '/data2';
  
  else
    disp(sprintf('analysis_commonrt_inputs: ERROR: invalid choice (%d), please start over.',cpselect));
    exit
  end

  disp(sprintf(' '));
  disp(sprintf('        Experiment start time (or a bit earlier) (UT): '));
  as_year  = input('           year: ');
  as_month = input('          month: ');
  as_day   = input('            day: ');
  as_hour  = input('           hour: ');

  disp(sprintf(' '));
  disp(sprintf('        Experiment stop time (or a bit later) (UT): '));
  ae_year  = input('           year: ');
  ae_month = input('          month: ');
  ae_day   = input('            day: ');
  ae_hour  = input('           hour: ');

  analysis_start = [as_year as_month as_day as_hour  0  0];
  analysis_end   = [ae_year ae_month ae_day ae_hour 59 59];

  analysis_integr = [60];  % integration time in s
  analysis_skip   = [ 0];  % optional, assumed to be zero if not specified
  
  realtime = 1;  % 1 = real time integration

% analysis control parameters
%   analysis_control(1) : if error of Ne exceeds this, no fit done
%   analysis_control(2) : iteration stopped, when step below this
%   analysis_control(3) : max number of iterations
%   analysis_control(4) : variance calculation; =1 for calculated, 2 for theoretical.
%   analysis_control(4) : variance calculation; =1 for calculated, 2 for theoretical.
  analysis_control = [.5 .01 100 1];

% display control flags
%   display_figures(1) : data dump shown
%   display_figures(2) : raw electron density shown
%   display_figures(3) : data and fitted curve for each fit shown
%   display_figures(4) : results shown after each dump
% display_figures = input( 'Select graphics output in the form [0 0 0 1]: ');
  display_figures = [0 0 0 1];

% uncomment the next line for loads of diagnostics from integrate
% trace_level = 3;

