% newsystem.m
% 20011002 bi  
% 20011104 bi  normalized system (magic) constant changed to 3.5 (uhf) and 14 (vhf)
% 20011116 bi  normalized system (magic) constant changed to 9.43 (uhf)


% correct tx power
  fprintf('newsystem: calling newsystem_txpower\n')
  newsystem_txpower


% correct pointing
  fprintf('newsystem: calling newsystem_pointing\n')
  newsystem_pointing


% reorganize and initialize data and parameters for guisdap analysis engine
  fprintf('newsystem: reorganizing and initializing data and parameters\n')


% init cal temp variable
  calTemp = d_parbl(21); 
  calTemp_before = calTemp;

% changed from 1.0 (default) to 5.0, 18 Oct 2001 MTR
% changed to 3.5 after reinitialization, 4 Nov 2001 bi
% calculated 9.4273 for cp1lt ac, 17.0782 for cp1lt lp, 16 Nov 2001 bi
% changed to 9.43, 16 Nov 2001 bi % 9.4273 for cp1lt ac, 17.0782 for cp1lt lp
% changed to 0.77, 17 Nov 2001 bi (cal1117)
% changed to 1.23, 18 Nov 2001 bi (cal1118)
  a_Magic_const_UHF = 1.23; % based on cp1lt ac of 10 March 2001.
  if datenum(d_time(1,1),d_time(1,2),d_time(1,3)) >= datenum(2001,4,23) ...
          & datenum(d_time(1,1),d_time(1,2),d_time(1,3)) <= datenum(2001,4,25)
    a_Magic_const_UHF = 0.78; % based on cp1lt lp of 24 April 2001.
  end
  if datenum(d_time(1,1),d_time(1,2),d_time(1,3)) >= datenum(2001,11,01) 
    a_Magic_const_UHF = 1.00; % based on cp1lt lp of 25 Nov 2001.
  end

% changed from 1.0 (default) to 20.0, 12 Sept 2001 MTR/BI (Ian McCrea calculates 19.8)
% changed to 14.0 after reinitialization, 4 Nov 2001 bi
  a_Magic_const_VHF = 14.0;

% CHANNEL GAINS BEFORE
  ch_gain_before = ch_gain;

if strcmp(name_pulse,'cp1lt')

  fprintf('newsystem: reorganising data for %s\n',name_pulse)
  d_data = cp1lt2gup(d_data);
  d_var1 = cp1lt2gup(d_var1);
  d_var2 = cp1lt2gup(d_var2);

  if calTemp < 10
    calTemp = 182;
  end

  a_Magic_const = a_Magic_const_UHF;

  antennaEfficiency = 0.633;

% Ian McCrea's adjustments
%
% the following is already set somewhere else in Guisdap
% it is equal to the UHF antenna gain
% ch_gain=10^4.81*ones(1,3); % the UHF antenna gain
%
% ch_gain(1) = ch_gain(1)*5.;
% ch_gain(2) = ch_gain(2)*5.;
% ch_gain(3) = ch_gain(3).*14.15;
% ch_gain = ch_gain*3;
%
% fprintf('newsystem: channel gains adjusted as per Ian McCrea for cp1lt\n')  

% the following is already set somewhere else in Guisdap
% it is required since this code is executed multiple times
  ch_gain = 10^4.81*ones(1,8); % the UHF antenna gain

  ch_gain = ch_gain(1:3); % cp1lt
% ch_gain(1) = ch_gain(1); % ac
% ch_gain(2) = ch_gain(2); % pp
  ch_gain(3) = ch_gain(3)*1.81; % lp

  ch_fradar = ch_fradar(1:3); % cp1lt
  ch_Pt = ch_Pt(1)*ones(1,3); % adjust number of channels


elseif ...
  strcmp(name_pulse,'tau2t') | ...
  strcmp(name_pulse,'tau2at')

  fprintf('newsystem: reorganising data for %s %s\n',name_pulse,version_expr)
  d_data = tau2at2gup(d_data,version_expr);
  d_var1 = tau2at2gup(d_var1,version_expr);
  d_var2 = tau2at2gup(d_var2,version_expr);

  if calTemp < 10
    calTemp = 182;
  end

  a_Magic_const = a_Magic_const_UHF;

  antennaEfficiency = 0.633;

  ch_gain = ch_gain(1:3);
  ch_fradar = ch_fradar(1:3);
  ch_Pt = ch_Pt(1)*ones(1,3); % adjust number of channels


elseif strcmp(name_pulse,'cp4bv') % 2-beam

  fprintf('newsystem: reorganising data for %s beam %i\n',name_pulse,vhf_beam)
  d_data = cp4bv2gup(d_data,vhf_beam);
  d_var1 = cp4bv2gup(d_var1,vhf_beam);
  d_var2 = cp4bv2gup(d_var2,vhf_beam);

  if calTemp < 10
    calTemp = 280;
  end

  a_Magic_const = a_Magic_const_VHF;

  antennaEfficiency = 0.3;  

  ch_gain = ch_gain(1:2); % cp4bv, one beam at a time
  ch_fradar = ch_fradar(1:2); % cp4bv, one beam at a time

% adjust number of channels for cp4bv
% ch_Pt = ch_Pt(1)*ones(1,4);  % two beams 
  ch_Pt = ch_Pt(1)*ones(1,2);  % one beam at a time % Nov 2000 bi
  

elseif strcmp(name_pulse,'cp7hv') % 1-beam

  fprintf('newsystem: reorganising data for %s\n',name_pulse)
  d_data = cp7hv2gup(d_data);
  d_var1 = cp7hv2gup(d_var1);
  d_var2 = cp7hv2gup(d_var2);

  if calTemp < 10
    calTemp = 280;
  end

  a_Magic_const = a_Magic_const_VHF;

  antennaEfficiency = 0.3;  

  ch_gain = ch_gain(1:9); % cp7hv
  ch_fradar = ch_fradar(1:9); % cp7hv

% adjust number of channels for cp7hv
% ch_Pt = ch_Pt(1)*ones(1,9);  % Original analysis, commented out 20011124 
  ch_Pt = ch_Pt(1);            % For Ingemar Haggstrom's initialisation
 

elseif ...
  strcmp(name_pulse,'tau1') | ...
  strcmp(name_pulse,'tau1v') | ...
  strcmp(name_pulse,'tau1av') % 2 beams

  fprintf('newsystem: reorganising data for %s beam %i\n',name_pulse,vhf_beam)
  d_data = tau1av2gup(d_data,vhf_beam);
  d_var1 = tau1av2gup(d_var1,vhf_beam);
  d_var2 = tau1av2gup(d_var2,vhf_beam);

  if calTemp < 10
    calTemp = 280;
  end

  a_Magic_const = a_Magic_const_VHF;

  antennaEfficiency = 0.3;  

  ch_gain = ch_gain(1:3); % tau1av, one beam at a time
  ch_fradar = ch_fradar(1:3); % tau1av, one beam at a time
  ch_Pt = ch_Pt(1)*ones(1,3);  

  
elseif ...
  strcmp(name_pulse,'tau1_singel_v') | ...
  strcmp(name_pulse,'tau1avsingle') % 1 beam

  fprintf('newsystem: reorganising data for %s\n',name_pulse)
  d_data = tau1avsingle2gup(d_data);
  d_var1 = tau1avsingle2gup(d_var1);
  d_var2 = tau1avsingle2gup(d_var2);

  if calTemp < 10
    calTemp = 280;
  end

% changed normalized system (magic) constant from 1 to 10 since densities too low MTR 27 Aug 2001
% changed from 10 to 20, 11 Sept 2001 MTR
% changed to 14.0 after reinitialization, 4 Nov 2001 bi
% changed to a_Magic_const_VHF, 17 Nov 2001 bi
  a_Magic_const = a_Magic_const_VHF;

  antennaEfficiency = 0.3;  

  ch_gain = ch_gain(1:3); % same as tau1av
  ch_fradar = ch_fradar(1:3); % same as tau1av
  ch_Pt = ch_Pt(1)*ones(1,3);  

  
end

  fprintf('newsystem: normalized system (magic) constant set to %i\n', a_Magic_const )

% CHANNEL GAINS BEFORE AND AFTER
  fprintf('newsystem: before adjustments: ch_gain %i\n',ch_gain_before ) 
  fprintf('newsystem:  after adjustments: ch_gain %i\n',ch_gain ) 

  fprintf('newsystem: normalized system (magic) constant set to %i\n', a_Magic_const )

  fprintf('newsystem: calibration temperature        %4i read from d_parbl(21)\n',calTemp_before )     
  fprintf('newsystem: calibration temperature set to %4i\n',calTemp ) 

  fprintf('newsystem: antenna efficiency set to %4i\n', antennaEfficiency )

