function d_gup = tau1avsingle2gup(d_data,do_beam)

% function rearranges signal processing output for GUISDAP
%
% /kst/exp/tau1avsingle/
% Matlab data file organization:
%
% GUISDAP design output
% >> design
% canon: tau1V_design
% canon: save /opt/guisdap/exps/tau1/tau1V_1GUPvar.mat 
% 
% 20010221 bi  correct for change in tau1v deco_map !
% 20010221 bi  copied from tau1v2gup
% 20010403 jm  
% 20011030 bi  name change from tau1v_singel_v to tau1avsingle

%{----------------------------------------------------------------------------

    % collect the required data from the original dump

    d_gup = zeros(22000+1,1); % must be large enough

    global GUP;
    global ch_az;
 
    if  isempty(GUP) 
    
        if length(d_data) == 20871 
            % This is version 1.20 -- tau1avsingle as it was intented

            GUP.s_addr{1} =   546 + (1:19737)-1; % skip over the x-lag data
            GUP.b_addr{1} = 20304 + (1:546)-1;   % use the "gain curve" as background
            GUP.c_addr{1} = 20850 + (1:21)-1;    % use the "gain curve inj" as injection

        elseif length(d_data) == 20911  
            % This is the version 1.10 that contains also lag-1 data
            % in noise injections
            
            GUP.s_addr{1} =   546 + (1:19737)-1; % skip over the x-lag data
            GUP.b_addr{1} = 20324 + (1:546)-1;   % use the "gain curve" as background
            GUP.c_addr{1} = 20870 + (1:21)-1;    % use the "gain curve inj" as injection
        else
            error(['Unexpected length of d_data ' num2str(length(d_data))])    
        end;
    end
    
    d_gup   = [ ...
              d_data(1+GUP.s_addr{1});
              d_data(1+GUP.b_addr{1});
              d_data(1+GUP.c_addr{1}) ...
              ];

    ch_az(1) = -0.5;

%}init

