function d_gup = cp1lt2gup(d_data,do_init)

% function rearranges signal processing output for GUISDAP
%
% see deco_map at /kst/exp/cp1lt/deco_map
%
% from /kst/exp/cp1lt/cp1lt.elan
% 18-Aug-2000 AW
% Matlab data file layout !!!!!OBS 0 indexed!!!!
% The physical channels are directly mapped to the cp1lt.tlan file
% so CH1 and CH1OFF means that start and stop sampling on the physical ch. 1
% 40-us pp
%       0-  239    Signal power profile 240 samples, physical ch 1
%     240-  359    Background power profile 120 samples, physical ch 1
%     360-  386    Calibration power profile 27 samples, physical ch 1
% lp
%     387-10486    Signal longpulse 25 lag 416 samples, physical ch 2
%   10487-15236    Background longpulse 25 lag 202 samples, physical ch 2
%   15237-15262    Calibration longpulse power profile 26 samples, physical ch 2
% 21-us pp for ac lag 0
%   15263-15571    Signal AC code power profile 309 samples, physical ch 3
% 21-us-baud ac
%   15572-34429    Signal AC code lag profiles 45 lag 
%                   285 samples fractionality 3 physical ch 3
% 21-us pp for ac lag 0
%   34430-34738    Signal Power profile 309 samples physical ch 4
%   34739-35014    Background Power profile 276 samples physical ch 4
%   35015-35053    Calibration Power profile 39 samples physical ch 4
%
% GUISDAP design output
% >> design
% canon: cp1lT_design
% canon: save /opt/guisdap/exps/cp4b/cp1lT_1GUPvar.mat 
% 

%{----------------------------------------------------------------------------

    % Collect the required data from the original dump

    d_gup = zeros(34436+1,1);

    global GUP;

%   cp1lt
%   not used
%     GUP.s_addr{ } = 15263:15571; % 21-us pp for ac lag 0
%     GUP.s_addr{ } = 34430:34738; % 21-us pp for ac lag 0
%   below same order as in design file

    if  isempty(GUP) 
      GUP.s_addr{1} = 15572:34429; % ac         18858
      GUP.b_addr{1} = 34739:35014; %              276
      GUP.c_addr{1} = 35015:35053; %               39
      GUP.s_addr{2} =     0:  239; % 40-us pp     240
      GUP.b_addr{2} =   240:  359; %              120
      GUP.c_addr{2} =   360:  386; %               27
      GUP.s_addr{3} =   387:10486; % lp         10100
      GUP.b_addr{3} = 10487:15236; %             4750
      GUP.c_addr{3} = 15237:15262; %               26
    end;

    d_gup = [ d_data(1+GUP.s_addr{1});
              d_data(1+GUP.b_addr{1});
              d_data(1+GUP.c_addr{1});
              d_data(1+GUP.s_addr{2});
              d_data(1+GUP.b_addr{2});
              d_data(1+GUP.c_addr{2});
              d_data(1+GUP.s_addr{3});
              d_data(1+GUP.b_addr{3});
              d_data(1+GUP.c_addr{3})];

%}init

