function d_gup = cp72gup(d_data,do_init)

% function rearranges signal processing output for GUISDAP
%
% deco_map from /kst/exp/cp7hv/deco_map
%  1  G   1        0  27840   0  29   1   0 928   0        0    27405   0   0
%  2  G   1    27840  27840   0  29   1   0 928   0    27405    27405   0   0
%  3  G   1    55680    166   0   0   1   0 166   0    54810      166   0   0
%  4  G   1    55846  10440   0  29   1   0 348   0    54976    10005   0   0
%  5  G   1    66286     58   0   0   1   0  58   0    64981       58   0   0
%
% GUISDAP design output
% Xmission defined: Virtual channel 1, real channel 7
%COR_uprog:   30 lps, total    30;  928 samples, total   928; ResMem used to 27404
%COR_uprog:   30 lps, total    60;  348 samples, total  1276; ResMem used to 37409
%COR_uprog:    1 lps, total    61;   58 samples, total  1334; ResMem used to 37467
% Xmission defined: Virtual channel 2, real channel 8
%COR_uprog:   30 lps, total    91;  928 samples, total  2262; ResMem used to 64872
%COR_uprog:   30 lps, total   121;  348 samples, total  2610; ResMem used to 74877
%COR_uprog:    1 lps, total   122;   58 samples, total  2668; ResMem used to 74935
% Xmission defined: Virtual channel 3, real channel 9
%COR_uprog:    1 lps, total   123;  166 samples, total  2834; ResMem used to 75101
%COR_uprog:   30 lps, total   153;  348 samples, total  3182; ResMem used to 85106
%COR_uprog:    1 lps, total   154;   58 samples, total  3240; ResMem used to 85164

%{----------------------------------------------------------------------------

    % Collect the required data from the original dump

    d_gup = zeros(85165,1);

    global GUP;
    global ch_az;
 
    if  isempty(GUP) 
		 GUP.s_addr{1} =     0:27404;
		 GUP.b_addr{1} = 54976:64980;
		 GUP.c_addr{1} = 64981:65038;
		 GUP.s_addr{2} = 27405:54809;
		 GUP.b_addr{2} = 54976:64980;
		 GUP.c_addr{2} = 64981:65038;
		 GUP.s_addr{3} = 54810:54975;
		 GUP.b_addr{3} = 54976:64980;
		 GUP.c_addr{3} = 64981:65038;
    end;

    d_gup = [ d_data(1+GUP.s_addr{1});
              d_data(1+GUP.b_addr{1});
              d_data(1+GUP.c_addr{1});
              d_data(1+GUP.s_addr{2});
              d_data(1+GUP.b_addr{2});
              d_data(1+GUP.c_addr{2});
              d_data(1+GUP.s_addr{3});
              d_data(1+GUP.b_addr{3});
              d_data(1+GUP.c_addr{3})];

%}init


