function d_gup = tau1av2gup(d_data,do_beam)

% function rearranges signal processing output for GUISDAP
%
% /kst/exp/tau1av/
% Matlab data file organization:
%
% GUISDAP design output
% >> design
% canon: tau1V_design
% canon: save /opt/guisdap/exps/tau1/tau1V_1GUPvar.mat 
% 
% 20010221 bi  correct for change in tau1v deco_map !
% 5-Apr-2001 Jm: Attempt to handle the "wrong" data laout, due to
%                extra noise injection samples. This should affect
%                only Mar-2001 data. 
% 20011030 bi  change name from tau1v to tau1av

%{----------------------------------------------------------------------------

    % collect the required data from the original dump

    global GUP;
    global ch_az;
 
    if  isempty(GUP) 
    
        if length(d_data) == 41742

            % This is the intended length of tau1av version 1.10
            % The addressed can be picked from levelmap_T110.dat
            
            d_gup = zeros(41742,1);
        
            GUP.s_addr{1} =     (1:19737) +   546 - 1;      % ac1.sig
            GUP.b_addr{1} =     (1:546)   + 20304 - 1;      % ac1.gain
            GUP.c_addr{1} =     (1:21)    + 20850 - 1;      % ac1.cal
            
            GUP.s_addr{2} =     (1:19737) +   546 - 1 + 20871;
            GUP.b_addr{2} =     (1:546)   + 20304 - 1 + 20871;
            GUP.c_addr{2} =     (1:21)    + 20850 - 1 + 20871;
            
        elseif length(d_data) == (41742 + 4*20)

            % This contains the extra noise injection lag-1 data
            % The addresses can also be picked from levelmap_T111.dat.
            
            d_gup = zeros(41822,1);
        
            GUP.s_addr{1} =     (1:19737) +   546 - 1;           % ac1.sig
            GUP.b_addr{1} =     (1:546)   + 20304 - 1 + 20;      % ac1.gain
            GUP.c_addr{1} =     (1:21)    + 20850 - 1 + 20;      % ac1.cal
            
            GUP.s_addr{2} =     (1:19737) +   546 - 1 + 20871 + 2*20;
            GUP.b_addr{2} =     (1:546)   + 20304 - 1 + 20871 + 3*20;
            GUP.c_addr{2} =     (1:21)    + 20850 - 1 + 20871 + 3*20;
            
        else
        
            error(['Unexpected d_data length for tau1av 1.10'])
            
        end        
    end;
    
    if do_beam == 1
        d_gup = [ ...
                  d_data(1+GUP.s_addr{1});
                  d_data(1+GUP.b_addr{1});
                  d_data(1+GUP.c_addr{1}) ...
                  ];

        ch_az = -0.5;

    elseif do_beam == 2

        d_gup = [ ...
                  d_data(1+GUP.s_addr{2});
                  d_data(1+GUP.b_addr{2});
                  d_data(1+GUP.c_addr{2}) ...
                  ];

        ch_az = -15.2;
                  
    else
        error('Invalid beam ID');
    end

%}init

