% newsystem_txpower.m

% UHF tx power notes
%
% UHF parameter block recorded the power output of only one klystron
% from the beginning of EROS3, sometime in 2000 (May ?) to when?? in 2001
% the power recorded was for only one klystron.
% note in /kst/eros3/lib/transmitter.tcl on 10 Apr 2001: power divided by 2 for 1 tube.
% note in /kst/eros3/lib/transmitter.tcl on 15 Oct 2001 (1331 UT): power calculated for 2 tubes again.
% Between April 2 and April 10 2001, the UHF transmitter ran with only one klystron,
%   but this was not reflected in the power values recorded in the parameter block.
%   Should only affect the UP run on April 3-4.
% transmitter_old.tcl was created on June 25 2001.
% It appears that from June 25 2001, UHF power was then calculated only if HV > 55 kV, otherwise = 0. 
%  note in /kst/eros3/lib/transmitter.tcl#Changed 13/11 2001 running one klystron (a), new calibration. Rj
%    (apparently 09:38 UT 9 Nov 2001)

% correct uhf tx power

%   if strcmp(name_antenna,'uhf')
%     d_parbl(8) = d_parbl(8) * 2.0;
%     fprintf('newsystem_txpower: doubled uhf power estimate to %i kW\n', fix(d_parbl(8)/1000))
%   end
% % if strcmp(name_expr(length(name_expr):(length(name_expr))),'t')
% %   d_parbl(8) = d_parbl(8) * 2.0;
% %   fprintf('newsystem_txpower: doubled uhf power estimate to %i kW\n', fix(d_parbl(8)/1000))
% % end

  if strcmp(name_expr(length(name_expr):(length(name_expr))),'t')

  % The 1 March date in the next if statement is still a guess. After Feb 6 but before March 9.

    if ( ...
         ( datenum(d_time(1,1),d_time(1,2),d_time(1,3)) >= datenum(2000,05,01) & ...
           datenum(d_time(1,1),d_time(1,2),d_time(1,3)) <= datenum(2001,03,01)   ) ...
       | ...
         ( datenum(d_time(1,1),d_time(1,2),d_time(1,3)) >= datenum(2001,06,28) & ...
           datenum(d_time(1,1),d_time(1,2),d_time(1,3),d_time(1,4),d_time(1,5),d_time(1,6)) ...
                                                        <= datenum(2001,10,15,13,31,00) )... 
       )

      fprintf('newsystem_txpower: doubling uhf tx power estimate\n')
      d_parbl(8) = d_parbl(8) * 2.0;
  
  % Between April 2 and April 10 2001, the UHF transmitter ran with only one klystron,
  % but this was not reflected in the power values recorded in the parameter block.
  % Should only affect the UP run on April 3-4.

    elseif datenum(d_time(1,1),d_time(1,2),d_time(1,3)) >= datenum(2001,4,2) ...
          & datenum(d_time(1,1),d_time(1,2),d_time(1,3)) <= datenum(2001,4,10) 
      fprintf('newsystem_txpower: halving uhf tx power estimate\n')
      d_parbl(8) = d_parbl(8) / 2.0;
    end  
  
  end

  fprintf('newsystem_txpower: tx power estimate is %i kW\n', fix(d_parbl(8)/1000))


% VHF tx power notes
% 
% The original version transmitter-old.tcl had:
% >     if { $HV >= 86 } {
% >         set A_pp [expr $HV*92.5 - 6755.0]
% >         set B_pp [expr $HV*60.0 - 3940.0]
% >     } elseif { $HV >= 80 } {
% >         set A_pp [expr $HV*56.6 - 3673.0]
% >         set B_pp [expr $HV*45.8 - 2722.0]
% >     } elseif { $HV >= 70 } {
% >         set A_pp [expr $HV*40.0 - 2340.0]
% >         set B_pp [expr $HV*46.5 - 2695.0]
% >     } elseif { $HV >= 20 } {
% >         set A_pp [expr $HV*6.57]
% >         set B_pp [expr $HV*7.0]
% 
% In transmitter.tcl:
% < # A new power calibration function has been implemented
% < # 9-Mar -2001 RJ
% < #9/3-01 if { $HV >=  40.0} {
% < #9/3-01     set A_pp [expr $HV*$HV*0.8164 - $HV*84.359+ 2201.0]
% < #9/3-01     set B_pp [expr $HV*$HV*0.76 - $HV*81.568+ 2206.0]
% 
% < # A new power calibration function has been implemented
% < # 20-Mar -2001 RJ
% <     if { $HV >=  55.0} {
% <         set A_pp [expr $HV*$HV*0.6374 - $HV*45.17+ 540.33]
% <         set B_pp [expr $HV*$HV*0.6336 - $HV*48.418+ 790.23]
%     } else {
%         set A_pp 0
%         set B_pp 0

