% init_old_system.m
% corrections for known bugs in pre-renovation mainland system data sets
% 20011103 bi  
% correction to bad CP-1-K AC imaginary data by Asko Huuskonen, 30 Jan 1996

if all(d_time(1,1:3)==[1992 2 8]) & name_site=='T';
  fprintf(' this data is odd\n')
  d_data(2010)=sum(d_data(2010:2024));
end

if all(d_time(1,1:3)==[1995 02 05]) & name_site=='T';
  fprintf(' bad data in the AC imaginary part\n')
  lpg=find(lpg_code==3); % these lpg's come from alternating code
  addr=lpg_addr(lpg)+1; % all the result memory addresses
                        % matlab addressing starts from 1
  d_data(addr)=real(d_data(addr))+i*zeros(length(addr),1);
end

if all(d_time(1,1:3)==[1995 02 06]) & name_site=='T';
  fprintf(' bad data in the AC imaginary part\n')
  lpg=find(lpg_code==3); % these lpg's come from alternating code
  addr=lpg_addr(lpg)+1; % all the result memory addresses
                        % matlab addressing starts from 1
  d_data(addr)=real(d_data(addr))+i*zeros(length(addr),1);
end

if name_site=='V' & strcmp(name_expr(1:4),'CP4B') & ch_el(1)==0,
  fprintf('GUISPERT: antenna elevation is zero, changing to the correct value\n')
  ch_el = [30.0*ones(1,8)];
end

if name_site=='V' & strcmp(name_expr(1:4),'CP7F'), 
  if ch_el(1)==0 & d_time(1,1:3)==[1998 03 13],
     fprintf('GUISPERT: antenna elevation is zero, changing to the correct value\n')
     ch_el = [30.0*ones(1,8)];
  end
  d_parbl(99) = d_parbl(99) + d_parbl(101);
  fprintf('GUISPERT: added klystron powers to %4i kW\n', d_parbl(99));
end

