%
% Makes a quick look plot from a GUISDAP output record
% Code mainly stolen from plot_result.m
%
% %W% %D%

 
ind=1:length(r_status);

r_Ne=r_param(ind,1)/1e11;
r_Ti=r_param(ind,2);
r_ratio=r_param(ind,3);
r_coll=r_param(ind,4);
r_vel=r_param(ind,5);
r_dNe=r_error(ind,1)/1e11;
r_dTi=r_error(ind,2);
r_dratio=r_error(ind,3);
r_dcoll=r_error(ind,4);
r_dvel=r_error(ind,5);
r_comp=r_dp(ind);
h=r_h(ind);
minheight=10*floor(min(h)/10);
maxheight=10*ceil(max(h)/10);

set(gcf,'PaperOrientation','portrait','PaperUnits','centim','Name','Tromso analysis');

time_date=[num2str(r_time(1,3)),'-',num2str(r_time(1,2)),'-',num2str(r_time(1,1)),' '];
time_date=[time_date,num2str(r_time(1,4)),':',num2str(r_time(1,5)),':',num2str(round(r_time(1,6))),' to '];
time_date=[time_date,num2str(r_time(2,4)),':',num2str(r_time(2,5)),':',num2str(round(r_time(2,6)))];
time_date=[time_date,' (az,el)=(',num2str(round(r_az)),',',num2str(round(r_el)),')'];
title_string=['EISCAT-',name_site,': ',name_expr,'  ',time_date];

axes('Position',[.1 .1 .2 .8],'DrawMode','fast')
p=plot([r_Ne-r_dNe,r_Ne+r_dNe]',[h,h]','b-',r_Ne,h,'go');
set(p,'MarkerSize',4)
set(gca,'FontSize',12)
xlabel('Ne [1e11 m-3]')
ylabel('Altitude [km]')
set(get(gca,'Xlabel'),'FontSize',12)
set(get(gca,'Ylabel'),'FontWeight','bold')
ax=axis;ax(1)=0;ax(3:4)=[minheight maxheight];
ax(1)=0;ax(2)=5;axis(ax);

axes('Position',[.31 .1 .2 .8],'DrawMode','fast')
p=plot([r_Ti.*(r_ratio-r_dratio)-r_dTi,r_Ti.*(r_ratio+r_dratio)+r_dTi]',[h,h]','b-',...
r_Ti.*r_ratio,h,'rx',...
[r_Ti-r_dTi,r_Ti+r_dTi]',[h,h]','b-',r_Ti,h,'go');
set(p,'MarkerSize',4)
set(gca,'YTickLabel',[' '],'FontSize',12)
xlabel('Ti(o), Te(x) [K]')
title(title_string)
set(get(gca,'Xlabel'),'FontSize',12)
ax=axis;ax(1)=0;ax(3:4)=[minheight maxheight];
ax(1)=0;ax(2)=5000;axis(ax);

axes('Position',[.52 .1 .2 .8],'DrawMode','fast')
p=plot([r_ratio-r_dratio,r_ratio+r_dratio]',[h,h]','b-',r_ratio,h,'go',...
       [1,1],[minheight maxheight],'Linewidth',0.5);
set(p,'MarkerSize',4)
set(gca,'YTickLabel',[' '],'FontSize',12)
xlabel('Te/Ti')
set(get(gca,'Xlabel'),'FontSize',12)
ax=axis;ax(3:4)=[minheight maxheight];
ax(1)=0;ax(2)=5;axis(ax);

axes('Position',[.73 .1 .2 .8],'DrawMode','fast')
% invert sign of GUISDAP velocities to match NCAR convention
r_vel=-r_vel;
p=plot([r_vel-r_dvel,r_vel+r_dvel]',[h,h]','b-',r_vel,h,'go',...
       [0,0],[minheight maxheight],'Linewidth',0.5);
set(p,'MarkerSize',4)
set(gca,'YTickLabel',[' '],'FontSize',12)
% print label with sign convention
xlabel('Vi [m/s] +ive away')
set(get(gca,'Xlabel'),'FontSize',12)
ax=axis;ax(3:4)=[minheight maxheight];
ax(1)=-300;ax(2)=300;axis(ax);

axes('Position',[.1 .1 .8 .8],'DrawMode','fast')
set(gca,'Visible','off')
alku=r_time(1,:);loppu=r_time(2,:);
tit=[sprintf('%2.0f/%2.0f/%4.0f',alku(3),alku(2),alku(1)),...
      sprintf('  %2.0f:%2.0f:%2.0f', alku(4),alku(5),alku(6)),...
      sprintf('-%2.0f:%2.0f:%2.0f',loppu(4),loppu(5),loppu(6))];
title(tit);
set(get(gca,'title'),'FontSize',20,'FontWeight','bold')

drawnow
