%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   GUP ver. 1.1       Sodankyla  17 Aug 1990                       %
%   copyright Asko Huuskonen, Markku Lehtinen, Matti Vallinkoski,   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% an_CP1K.m
% This file defines the analysis interval, the postintegration strategy and
% the altitude range to be analyzed.

start_GUP

% Experiment name and site and paths
name_expr='CP1K';     name_site='T';
data_path=['/geo/gmt/askoh/datat/910222/'];   % data folder
result_path=[path_GUP 'garbage:'];         % result folder

% Time interval to analyze in form
%               Year Month Day Hour Min Sec
analysis_start=[1991   2    22  12  00   0];
analysis_end=  [1991   2    22  12  50   0];

% postintegration strategy defines how many seconds first to skip and integrate.
% the vectors are used cyclically
analysis_integr=[600];
analysis_skip  =[   0];  % Optional, assumed to be zero if not specified

analysis_altit=[100 400];
%analysis_minwidth=0.5*diff(analysis_altit);
%analysis_maxwidth=4*diff(analysis_altit);
analysis_classic=1;

% Some optional parameters control the program execution and output
% All these are set in 'check_parameters' if not specified here

% Choose at most one of these; if both are true, data is shown.
display_results=1; % If true, results are shown 
display_fit=0;     % if true, data and fitted curve are shown

an_start
