% cp1lT_design.m
% GUISDAP 1.65
% 2001.02.22 BI  edited from cp7hV_design.m

% impulse response parameter for get_impresp
p_dtau    = 1.0;                % us

% set up some lengths (in us)
acPulseLength     =    336;
ppPulseLength     =     40;
lpPulseLength     =    350;
cycleLength       =  21130; % from tlan file
acBitlen          =    7*3;
acNbits           =     16;

% and some reception windows
% plus modifications to get the right number of samples
% and to make a pulse scheme that guisdap will accept
acOffset  =    0;
ppOffset  = 4000;
lpOffset  = 19000;
bacOffset = 6702;
calOffset = 9410;

%%ReceiverWindowAC    = acOffset + [   700  2695+17];               % ch3
BackgroundWindowAC  = acOffset + [   771  2703- 7 ] + bacOffset; % ch4
CalibrationWindowAC = acOffset + [    57   330- 7 ] + calOffset; % ch4
ReceiverWindowPP    = ppOffset + [   932  3332-10 ];             % ch1
BackgroundWindowPP  = ppOffset + [  1503  2703-10 ] + bacOffset; % ch1
CalibrationWindowPP = ppOffset + [    60   330-10 ] + calOffset; % ch1
ReceiverWindowLP    = lpOffset + [   935  5095-10 ];             % ch2
BackgroundWindowLP  = lpOffset + [   683  2703-10 ] + bacOffset; % ch2
CalibrationWindowLP = lpOffset + [    70   330-10 ] + calOffset; % ch2

DS_start( 'EISCAT',2*100000,1)

% correct the frequencies for the UHF
ch_fradar = 930.5e6*ones(1,8); % Hz

DS_set( 'clear' )
DS_set( 'cycle', 2 * cycleLength )

DS_set( 'adcint', 7 )
[Taps,T0] = get_impresp('/kst/dsp/fir/b75d105.fir',p_dtau,0);
%[Taps,T0] = get_impresp('/kst/dsp/fir/b15d225.fir',p_dtau,0); %!!!!!! WRONG FILTER
%[Taps,T0] = get_impresp('/kst/dsp/fir/cp1fir.fir',p_dtau,0); %!!!!!! WRONG FILTER
DS_set( 'taps', Taps )

% ALTERNATING CODE TRANSMISSION

DS_set( 'channel', 1, 'XMITtime', acOffset + 80, 'bitlen', 3*7 )

% ALTERNATING CODE RECEPTIOIN

DS_set( 'Nbits',16)

DS_set('RECtime', acOffset + 700);

%DS_set('gates',N - (CH.nbits-1)*round(CH.baud/CH.tau)); 
DS_set('gates',285 - (16-1)*round(21/7)); 

%DS_set('lags', CH.fstlag:CH.tau:CH.maxlag);
DS_set( 'lags', 7:7:(44*7));

% ALTERNATING CODE BACKGROUND

DS_set( 'Blags', 0)
DS_set( 'Bwindow', BackgroundWindowAC )

% ALTERNATING CODE CALIBRATION

DS_set( 'Cwindow', CalibrationWindowAC )
DS_set('go')

% 40 USEC POWERPROFILE >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

DS_set( 'clear' )
DS_set( 'cycle', 2 * cycleLength )

% 40 USEC PP TRANSMISSION

 DS_set( 'adcint', 10 )
[Taps,T0] = get_impresp('/kst/dsp/fir/b25d150.fir',p_dtau,0);
%[Taps,T0] = get_impresp('/kst/dsp/fir/cp1fir.fir',p_dtau,0); %!!!!!! WRONG FILTER
DS_set( 'taps', Taps )
 
 DS_set( 'channel', 2, 'XMITtime', ppOffset + 432, 'bitlen', ppPulseLength )
 
% 40 USEC PP SIGNAL RECEPTION

 DS_set( 'lags', 0 )
 DS_set( 'RECWindow', ReceiverWindowPP )
 
% 40 US PP  BAGR

 DS_set( 'Blags', 0 )
 DS_set( 'Bwindow', BackgroundWindowPP )

% 40 US PP  CALIBRATION
 
 DS_set( 'Cwindow', CalibrationWindowPP )
 DS_set('go')

% 40 USEC POWERPROFILE >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

DS_set( 'clear' )
DS_set( 'cycle', 2 * cycleLength )
 DS_set( 'adcint', 10 )

DS_set( 'channel', 3, 'XMITtime', lpOffset + 80, 'bitlen', lpPulseLength )
DS_set( 'lags', 0:10:240 )
DS_set( 'RECWindow', ReceiverWindowLP )
DS_set( 'Blags', 0:10:240 )
DS_set( 'Bwindow', BackgroundWindowLP )
DS_set( 'Cwindow', CalibrationWindowLP )
DS_set('go')
