% cp4bV_design.m  VHF CP4 two beam programme
% GUISDAP 1.65
%

% Impulse response

p_dtau    = 1.0;                % us
[Taps,T0]   = get_impresp('/kst/dsp/fir/b15d225.fir',p_dtau,0);

% Set up some lengths

longPulseLength   =    900;
ppPulseLength     =     45;
cycleLength       =  14000;

% and some reception window, plus modifications to get the right number of samples

ReceiverWindowLP1 = [  3455 13025-15 ]; 
ReceiverWindowPP1 = [  2132  4622-15 ];
CalibrationWindow1= [ 13100 13970-15 ]; 
BackgroundWindow1 = [  9110 13025-15 ]; 

ReceiverWindowLP2 = [  3455 13025-15 ]; 
ReceiverWindowPP2 = [  2132  4622-15 ];
CalibrationWindow2= [ 13100 13970-15 ]; 
BackgroundWindow2 = [  9110 13025-15 ]; 

DS_start( 'EISCAT' )

% correct the frequencies for the VHF
ch_fradar = 224e6*ones(1,3); % Hz

DS_set( 'clear' )
DS_set( 'adcint', 15 )
DS_set( 'taps', Taps )

% need to split two beams in time for guisdap
% so that two freqs do not appear to be txed at same time
DS_set( 'cycle', 2 * cycleLength )

DS_set( 'channel', 1, 'XMITtime', 100, 'bitlen', longPulseLength )
DS_set( 'lags', 0:15:435 )
DS_set( 'RECWindow', ReceiverWindowLP1 )
DS_set( 'Blags', 0:15:435 )
DS_set( 'Bwindow', BackgroundWindow1 )
DS_set( 'Cwindow', CalibrationWindow1 )
DS_set('go')

%DS_set( 'channel', 2, 'XMITtime', cycleLength+100, 'bitlen', longPulseLength )
%DS_set( 'lags', 0:15:435 )
%DS_set( 'RECWindow', cycleLength+ReceiverWindowLP2 )
%DS_set( 'Blags', 0:15:435 )
%DS_set( 'Bwindow', cycleLength+BackgroundWindow2 )
%DS_set( 'Cwindow', cycleLength+CalibrationWindow2 )
%DS_set('go')

%DS_set( 'channel', 3, 'XMITtime', 1002, 'bitlen', ppPulseLength )
DS_set( 'channel', 2, 'XMITtime', 1002, 'bitlen', ppPulseLength )
DS_set( 'lags', 0 )
DS_set( 'RECWindow', ReceiverWindowPP1 )
DS_set( 'Blags', 0 )
DS_set( 'Bwindow', BackgroundWindow1 )
DS_set( 'Cwindow', CalibrationWindow1 )
DS_set('go')

%DS_set( 'channel', 4, 'XMITtime', cycleLength+1002, 'bitlen', ppPulseLength )
%DS_set( 'lags', 0 )
%DS_set( 'RECWindow', cycleLength+ReceiverWindowPP2 )
%DS_set( 'Blags', 0 )
%DS_set( 'Bwindow', cycleLength+BackgroundWindow2 )
%DS_set( 'Cwindow', cycleLength+CalibrationWindow2 )
%DS_set('go')
