% cp7hV_design.m: VHF CP7 high altitude programme
% GUISDAP 1.65
% 2001.02.22 BI  lags corrected (?) from cp7V_design.m

% impulse response
p_dtau    = 1.0; % us
[Taps,T0]   = get_impresp('/kst/dsp/fir/b30d225.fir',p_dtau,0);

% set up some lengths in us

longPulseLength   =    924;
ppPulseLength     =     45;
cycleLength       =  18465;

% and some reception windows
% plus modifications to get the right number of samples
% 15 us sampling

ReceiverWindowLP1 = [  2675 16595-15 ]; %  [  2675 16585 ];
ReceiverWindowLP2 = [  3600 17522-15 ]; %  [  3600 17510 ];
ReceiverWindowPP  = [  2480  4970-15 ]; %  [  2480  4965 ];
CalibrationWindow = [ 17565 18435-15 ]; %  [ 17565 18420 ];
BackgroundWindow  = [ 12302 17522-15 ]; %  [ 12302 17507 ];

DS_start( 'EISCAT' )

% correct the frequencies for the VHF

ch_fradar = 224e6*ones(1,8); % Hz

DS_set( 'clear' )

DS_set( 'adcint', 15 )
DS_set( 'taps', Taps )

DS_set( 'cycle', 2 * cycleLength )

DS_set( 'channel', 7, 'XMITtime', 88, 'bitlen', longPulseLength )
DS_set( 'lags' , 0:15:435 )
DS_set( 'RECWindow', ReceiverWindowLP1 )
DS_set( 'Blags', 0:15:435 )
DS_set( 'Bwindow', cycleLength + BackgroundWindow )
DS_set( 'Cwindow', cycleLength + CalibrationWindow )

DS_set('go')

DS_set( 'channel', 8, 'XMITtime', 1013, 'bitlen', longPulseLength )
DS_set( 'lags' , 0:15:435 )
DS_set( 'RECWindow', ReceiverWindowLP2 )
DS_set( 'Blags', 0:15:435 )
DS_set( 'Bwindow', cycleLength + BackgroundWindow )
DS_set( 'Cwindow', cycleLength + CalibrationWindow )

DS_set('go')

DS_set( 'channel', 9, 'XMITtime', 1940, 'bitlen', ppPulseLength )
DS_set( 'lags' , 0 )
DS_set( 'RECWindow', ReceiverWindowPP )
DS_set( 'Blags', 0 )
DS_set( 'Bwindow', cycleLength + BackgroundWindow )
DS_set( 'Cwindow', cycleLength + CalibrationWindow )

DS_set('go')

