% tau1vV_design.m
% GUISDAP 1.65
%
% 20010227 bi  edited from cp1lT_design.m
%
% tau1v is a split beam experiment, and the actual dump contains
% identical data sets from both beams.  Our strategy in analysis
% is to imagine that we have a single beam only.  The Guisdap
% preprocessor routine, called via GUISPERT.m, picks one of the
% two data sets to analyze.  Thus, the analysis should be identical
% to the analysis of tau1vsingle. 
% 5-Apr-2001 Jm
%
% tau1 is identical to tau1av
% up to at least 2001.11.01, tau1v is also identical to tau1av
% 20011101 bi


% impulse response parameter for get_impresp

  p_dtau    = 1.0;                % us

% set up some lengths (in us)

  acPulseLength     =  16*3*24;
  cycleLength       =  40000; % in principle from tlan file but here just made up
  acBitlen          =   24*3;
  acNbits           =     16;

% and some reception windows
% plus modifications to get the right number of samples
% and to make a pulse scheme that guisdap will accept

  sigOffset =     0;
  bacOffset = 20000;
  calOffset = 20000;

% ReceiverWindowAC    = [  1919 15023-24 ] + sigOffset; % ch1 or ch2
  BackgroundWindowAC  = [  1919 15023-24 ] + bacOffset; % ch4 or ch5
  CalibrationWindowAC = [ 15072 15576-24 ] + calOffset; % ch4 or ch5

  DS_start( 'EISCAT',2*100000,1)

% correct the frequencies for the VHF

  ch_fradar = 224.0e6*ones(1,8); % Hz

  DS_set( 'clear' )
  DS_set( 'cycle', cycleLength )

  DS_set( 'adcint', 24 )
  [Taps,T0] = get_impresp('/kst/dsp/fir/b21d360.fir',p_dtau,0);
  DS_set( 'taps', Taps )

% ALTERNATING CODE TRANSMISSION

  DS_set( 'channel', 1, 'XMITtime', sigOffset + 100, 'bitlen', 3*24 )

% ALTERNATING CODE RECEPTION

  DS_set( 'Nbits',16)

  DS_set('RECtime', sigOffset + 1919);

% DS_set('gates',N - (CH.nbits-1)*round(CH.baud/CH.tau)); 

% DS_set('gates',546 - (16-1)*round(72/24));
  DS_set('gates',546 - (16-1)*3); % 3 times oversampling

% DS_set('lags', CH.fstlag:CH.tau:CH.maxlag);

  DS_set( 'lags', 24:24:(23*24));

% BACKGROUND FOR THE NOISE INJECTION (ALTERNATING CODE BACKGROUND)

  DS_set( 'Blags', 0)
  DS_set( 'Bwindow', BackgroundWindowAC )

% NOISE INJECTION (ALTERNATING CODE CALIBRATION)

  DS_set( 'Cwindow', CalibrationWindowAC )
  DS_set('go')

