% canon.m: A function that repairs file path names for any particular system 
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
% function to change directory characters in file names to 
% be good for various file systems
% Does not work for disk names in DOS - somebody, please correct this
%
% Modified to handle DOS disk drives, 940613 CJH
%
function res=canon(fn,output);

if nargin==1, output=1; end
comp=computer;
comp(20)=' ';
if comp(1:2)=='PC', c='\'; 
elseif comp(1:3)=='MAC', c=':';
elseif comp(1:5)=='VAXVM', c='\';
else c='/';
end;
loc=find( (fn==':') | (fn=='/') | (fn=='\') );

% for a DOS machine, a ':' in the second character probably indicates
% a disk drive designator such as A: or C: - this must not be changed
% to a '\'
if length(loc) > 0
  if comp(1:2)=='PC'
    if loc(1)==2, loc(1)=[]; end
  end;
end;

fn(loc)=setstr(ones(1,length(loc))*abs(c));
res=fn;

% Produce output in lowercase letters when PC-Matlab is used
if comp(1:2)=='PC' res=lower(fn); end;

if output, fprintf(['m165/canon: ',res,'\n']); end

