% error_estimate.m: Calculates error estimates for inversion of dirthe
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
  function [error,correl,alpha]=error_estimate(aa,variance,kd2,p_coeffg,f_womega,p_om,pldfvv)
 
  warning_state=warning;
  warning off
  comp=aa(6);aa=aa(1:5);
  if min(size(variance))==1, diagonal=1;end
  if diagonal,
    invsigma=1 ./variance;
    apu=invsigma*ones(1,length(aa));
  else
    invsigma=inv(variance);
  end

  ya=dirthe([aa,comp],p_coeffg,f_womega,kd2,p_om,pldfvv);
  dyda=zeros(length(ya),length(aa));
  for i=(1:length(aa)) 
    aa2=aa; aa2(i)=aa(i)+0.0001;
    dyda(:,i)=(ya-dirthe([aa2,comp],p_coeffg,f_womega,kd2,p_om,pldfvv))/0.0001;
   end 
   if diagonal,
     alpha=dyda'*(apu.*dyda);
   else
     alpha=dyda'*invsigma*dyda;
   end
alpha=inv(alpha);
error=sqrt(diag(alpha))';
correl=alpha./(error'*error);
warning(warning_state);