% impuls_resp.m: Calculates filter responces from ch_filter variable.
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
% Calculates the filter impulse responses, based on the data saved
% in the variable ch_filter by the PS_LIFILT and PS_BUFILT routines
%
% See also: lin_filt but_filt

ch_p=[];
channels=find(ch_filter(1,:)==1 | ch_filter(1,:)==2); % these channels in use
while length(channels)>0,
  filtertype=ch_filter(1,channels(1));
  BW=ch_filter(2,channels(1));
  ind=find(ch_filter(1,channels)==filtertype & ch_filter(2,channels)==BW);
  if filtertype==1,
    but_filt(BW,channels(ind));
  elseif  filtertype==2,
    lin_filt(BW,channels(ind));
  end
  channels(ind)=[];
end
clear filtertype BW ind channels
