% Init_graphics.m: opens a sufficient number of figure windows. 
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
% The sizes and locations are defined here.
% Parameter:
% di_figures (global): requested windows (on input) and figure handles (on
% output)

Positions=...
[  50, 50,550,300;  % Correlator dump
   50, 50,200,400;  % Raw electron density
  600,300,600,400;  % Fit results
  500,200,600,400]; % Results

Names=...
['Correlator dump, real part';
 '   Raw electron density   ';
 '  Fit results and quality ';
 '       Results            '];

undefined=di_figures;

unused=[];
for F=get(0,'Children')'
  if strcmp(get(F,'type'),'figure')==1
    used=0;
    UserData=get(F,'UserData');
    if length(UserData)==1
      if UserData>=1 & UserData<=4,
        if di_figures(UserData), 
          undefined(UserData)=0;
          di_figures(UserData)=F;
          used=1;
        end
      end
    end
    if ~used, unused=[unused, F]; end
  end
end

for fig=find(undefined);
  if length(unused),
    F=unused(1);
    unused(1)=[];
  else
    F=figure;
  end
  figure(F), clf
  di_figures(fig)=F;
  set(F,'Position',Positions(fig,:),'NumberTitle','off','Name',Names(fig,:),'UserData',fig);
  set(F,'DefaultAxesFontName','helvetica')
  set(F,'DefaultTextFontName','helvetica')
  set(F,'DefaultAxesFontWeight','bold')
  set(F,'DefaultTextFontWeight','bold')
  set(F,'DefaultAxesFontSize',14)
  set(F,'DefaultTextFontSize',14)
end

clear undefined  Positions  Names  UserData  unused  fig  F
