% load_initfile.m: loads the ambiguity functions etc. into the workspace for analysis
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
% The script assumed that variables name_expr and name_site exist in the workspace
% The script contains reference to EISCAT remote sites. However, the script works
% without modifications for other radars as long as name_site is different from K and S
%
% See also: path_expr save_toinitfile 
%
clear vcg_Aenv  

temp=[path_expr name_expr name_site];
if name_site=='K' | name_site=='S';
  temp=[path_expr name_expr 'R'];
end
if exist('d_rcprog')==1, rcp=d_rcprog; else rcp=0; end
if exist(canon([temp '_' int2str(rcp) 'init.mat'],0))==2,
  eval(canon(['load ' temp '_' int2str(rcp) 'init']))
elseif exist(canon([temp 'init.mat'],0))==2,
  eval(canon(['load ' temp 'init']))
else
  fprintf(['\n\n\n File    ', canon([temp 'init.mat'],0),'    not found \n\n\n'])
  error(' ')
end
if GUP_iniver<1.52,
  fprintf('*\n*\n* Files produced by GUP version %.2f not usable\n', GUP_iniver)
  fprintf('* Please, reinitialize the experiment with GUP 1.52 or later\n*\n*\n')
  error(' ')
end

if exist('vcg_Aenv')
  vc_Aenv=vcg_Aenv(:,vc_group);
  vc_Ap=vcg_Ap(:,vc_group);
  vc_Apenv=vcg_Apenv(:,vc_group);
  vc_penv=vcg_penv(:,vc_group);
  vc_penvabs=vcg_penvabs(:,vc_group);
  clear vcg_Aenv vcg_Ap vcg_Apenv vcg_penv vcg_penvabs
end
clear rcp temp
