% lpg_tex: A script to output lpg_ parameters in TeX form
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%  
% suitable to be printed with tex code in file lpg.tex
% 
% See also: init_GUP
fil=canon([path_expr name_expr name_site apustr 'lpg_i.tex']);
if exist(fil)==2, delete(fil), end

form1=['\\+%3.0f&%2.0f&  '];
form2=['& %3.0f&%6.0f&%6.0f&%3.0f&%3.0f&%3.0f&%3.0f&%4.0f&%4.0f\\cr\n'];
for ind=1:length(lpg_ND)
  form=[form1,setstr(lpg_bcs(ind)),form2];
  fprintf(fil,form,ind,lpg_code(ind),lpg_lag(ind)*p_dtau,lpg_h(ind)*p_dtau,...
                   lpg_w(ind)*p_dtau,lpg_dt(ind)*p_dtau,lpg_ND(ind),lpg_T(ind),...
                    lpg_nt(ind),lpg_ra(ind),lpg_ri(ind));
end;
closefile
clear fil ind

% The above code is equivalent to, but much faster than the original one
% The original is much easier to understand, on the other hand
% The speed difference is important especially when writing is not done
% to a local disc drive
%for ind=1:length(lpg_ND)
%  fprintf(fil,'\\+%3.0f&',ind);  
%  fprintf(fil,'%2.0f&',lpg_code(ind));
%  fprintf(fil,['  ',setstr(lpg_bcs(ind)),'& ']); 
%  fprintf(fil,'%3.0f&',lpg_lag(ind)*p_dtau);
%  fprintf(fil,'%6.0f&',lpg_h(ind)*p_dtau);
%  fprintf(fil,'%6.0f&',lpg_w(ind)*p_dtau);
%  fprintf(fil,'%3.0f&',lpg_dt(ind)*p_dtau);
%  fprintf(fil,'%3.0f&',lpg_ND(ind));
%  fprintf(fil,'%3.0f&',lpg_T(ind));
%  fprintf(fil,'%3.0f&',lpg_nt(ind));
%  fprintf(fil,'%4.0f&',lpg_ra(ind));
%  fprintf(fil,'%4.0f\\cr\n',lpg_ri(ind));
%end;
%closefile
%clear fil ind
