% transf.m : transforms user parameters to spectrum parameters
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
%
% Parameters:
% p: plasma parameters in scaled units
% [nin0,tit0,mim0,psi,vi] : general spectrum parameters
%
% See also: spec, dirthe, real_to_scaled
%
% [nin0,tit0,mim0,psi,vi]=transf(p)
%
  function [nin0,tit0,mim0,psi,vi]=transf(p)

		m1 = 30.5*1.6605402e-27; 
		m2 = 16*1.6605402e-27;  
		me = 9.1093897e-31;	
		m0 = m1;
%
    psi0=p(4);                        % psi0
%
    nin0(1)=p(1)*(1-p(6));            % N1/Ne
    nin0(2)=p(1)*p(6);                % N2/Ne
    nin0(3)=p(1);                     % Ne/N0;
    tit0(1)=p(2);                     % T1/T0
    tit0(2)=p(2);                     % T2=T1
    tit0(3)=p(2)*p(3);                % Te/T0
    mim0(1)=m1/m0;                    % m1/m0
    mim0(2)=m2/m0;                    % m2/m0
    mim0(3)=me/m0;                    % me/m0 from amu
    vi(1)=p(5);                       % v1/v0; v0=phase velocity om0/kscatt
    vi(2)=p(5);                       % v2/v0
    vi(3)=p(5);                       % ve/v0
    psi(1)=psi0;                      % psi1
    psi(2)=psi0;                      % psi2=psi1 for all temperatures
    psi(3)=psi0*0.35714;              % psie independently of Te/Ti
