% wrlpg.m: calculates the range ambiguity function for a lag profile group
% GUISDAP v.1.60 96-05-27 Copyright Asko Huuskonen and Markku Lehtinen
%
% See also: lpgwrcalc wr
%
%  function wsum=wrlpg(lpg)
  function wsum=wrlpg(lpg)

global lp_t1 lp_t2 lp_dt lp_vc lp_nfir lp_fir

wsum=0;
for lp=lpg_lp(lpg)
  [w,r]=wr(lp_vc(lp),lp_t1(lp),lp_t2(lp));
  if length(r)>0,
    maxr=r(length(r))+(lp_nfir(lp)-1)*lp_dt(lp);
    if length(wsum)<maxr,wsum(maxr,1)=0;end;
      for ind=1:lp_nfir(lp)
        R=r+(ind-1)*lp_dt(lp);
        wsum(round(R))=wsum(round(R))+lp_fir(ind,lp)*w;
      end
  else
    fprintf('For lag profile %.0f the range ambiguity function is empty\n',lp)
  end
end
