# include <stdlib.h>
# include <stdio.h>
# include <math.h>
# include "mex.h"

#define	max(A, B)	((A) > (B) ? (A) : (B))
#define	min(A, B)	((A) < (B) ? (A) : (B))
#define ddabs(A) ((A)<(0) ? (-A) : (A))
#define IND2(k1,k2,N) ((k1+N*k2))								/* Index of regular matrix */

#ifdef ANSI_C
	extern void Transf(long ns,double *pPr,double *nin0Pr,double
*tit0Pr,double *mim0Pr,double *psiPr,double *viPr);
	extern void specCalc(double *pldfvPr,double *pldfvPi,double *nin0Pr,double
*tit0Pr,long ns,long nion,double *mim0Pr,double *psiPr,double *viPr,double
*kd2Pr,long nom,double *omPr,double *resPr);
#else
	extern void Transf();
	extern void specCalc();
#endif

#ifdef ANSI_C
	DirtheCalc(long ns,long aaN,double *aaPr,double *coefPr,long womM,
			   double *womPr,double *kd2Pr,long nom,double *omPr,
			   double *pldfvPr,double *pldfvPi,double *acfPr)
#else
	DirtheCalc(ns,aaN,aaPr,coefPr,womM,womPr,kd2Pr,nom,omPr,pldfvPr,pldfvPi,acfPr)
		long ns,aaN,womM,nom;
		double *aaPr,*coefPr,*womPr,*kd2Pr,*omPr,*acfPr,*pldfvPr,*pldfvPi;
#endif	
	{
#ifdef MAC
	register extended sum;
#else
	register double sum;
#endif	
	unsigned long i,j;
	Matrix *spec,*nin0,*tit0,*mim0,*psi,*vi, *p;
	double *nin0Pr,*tit0Pr,*mim0Pr,*psiPr,*viPr,*specPr;
	double *pPr;
	unsigned long nion = 2;


	/* Copy matrix AA_IN into p and then use p */
	
	p = mxCreateFull(ns,aaN,REAL);
	pPr = mxGetPr(p);
	for(i=0;i<(aaN*ns);i++)
		pPr[i] = aaPr[i];
	
	
 pPr[0]=max(0.005,pPr[0]);
	pPr[1]=min(100,max(0.1,pPr[1]));
	pPr[2]=min(8,max(0.20,pPr[2]));
	pPr[3]=max(pPr[3],0);
	pPr[3]=pPr[3]/sqrt(pPr[1]);

	nin0 = mxCreateFull(ns, nion+1, REAL);
	tit0 = mxCreateFull(ns, nion+1, REAL);
	mim0 = mxCreateFull(ns, nion+1, REAL);
	psi = mxCreateFull(ns, nion+1, REAL);
	vi = mxCreateFull(ns, nion+1, REAL);

	nin0Pr = mxGetPr(nin0);
	tit0Pr = mxGetPr(tit0);
	mim0Pr = mxGetPr(mim0);
	psiPr = mxGetPr(psi);
	viPr = mxGetPr(vi);

	Transf(ns,pPr,nin0Pr,tit0Pr,mim0Pr,psiPr,viPr);

	spec = mxCreateFull(nom,ns,REAL);

	specPr = mxGetPr(spec);

	specCalc(pldfvPr,pldfvPi,nin0Pr,tit0Pr,ns,nion,mim0Pr,psiPr,viPr,kd2Pr,nom,omPr,specPr);
	
	/*acf=[p_coeffg.*(f_womega*s);col(aa)];*/

	for(i=0;i<womM;i++)
		{
		sum = 0;
		for(j=0;j<mxGetM(spec);j++)
			{
			sum += womPr[IND2(i,j,womM)]*specPr[j];
			}
		acfPr[i]=coefPr[i]*sum;
		}
	for(i=womM;i<(womM+aaN-1);i++)
		{
		acfPr[i]= aaPr[i-womM];
		}



	}
