# include <stdlib.h>
# include <stdio.h>
# include <math.h>
# include "mex.h"

#define TEXT   1			/* mat.type indicating text */
#define MATRIX 0			/* mat.type indicating matrix */

#define ddabs(A) ((A)<(0) ? (-A) : (A))


/* Output Arguments */
#define	AA_OUT			plhs[0]
#define	CHI2_OUT		plhs[1]
#define	ITS_OUT			plhs[2]
#define	ALPHA_OUT		plhs[3]

/* Input Arguments */

#define	AA_IN			prhs[0]
#define	YM_IN			prhs[1]
#define	VARIANCE_IN		prhs[2]
#define	FTOL_IN			prhs[3]
#define ITMAX_IN		prhs[4]
#define KD2_IN			prhs[5]
#define P_COEFFG_IN		prhs[6]
#define WOM_IN			prhs[7]
#define OM_IN			prhs[8]
#define PLDFVV_IN	    prhs[9]
/*
 *
 *
 * Beginning of the program !!!!!!!!
 *
 *
 *
 */
#ifdef ANSI_C
	extern MrqmndiagCalc(long ns,long aaN,double *aaPr,double *ymPr, double *variancePr,
					 long varianceM,long varianceN,double* ftolPr, double *itMaxPr,
					 double *coefPr,long coefM,long coefN,long womM,double *womPr,double *kd2Pr,
					 long nom,double *omPr,double *aaOutPr,double *chi2Pr,double *itsPr,double *alphaPr,
					 double *pldfvPr,double *pldfvPi);
#else
	extern void MrqmndiagCalc();
#endif

#ifdef ANSI_C
	void mexFunction(int nlhs, Matrix *plhs[], int nrhs, Matrix *prhs[])
#else
	mexFunction(nlhs, plhs, nrhs, prhs)
	int nlhs, nrhs;
	Matrix *plhs[], *prhs[];
#endif
{
	long nom,womM,aaN,ns,varianceM,varianceN,coefM,coefN;
	double *aaPr,*coefPr,*womPr,*kd2Pr,*omPr, *ymPr, *variancePr,*ftolPr,*itMaxPr;
	double *aaOutPr,*itsPr,*chi2Pr,*alphaPr,*pldfvPr,*pldfvPi;


/* Deal with the input arguments */

/* First check that we get the proper number of input & output arguments */

	if (nrhs != 10)
		mexErrMsgTxt("Mrqmndiag requires ten input arguments.");
	if (nlhs != 4)
		mexErrMsgTxt("Mrqmndiag requires four output arguments.");
	
/* Then get the pointers to the data part of the matrices */

	ns = mxGetM(AA_IN);
	aaN = mxGetN(AA_IN);
	aaPr = mxGetPr(AA_IN);
	
	ymPr = mxGetPr(YM_IN);

	variancePr = mxGetPr(VARIANCE_IN);
	varianceM = mxGetM(VARIANCE_IN);
	varianceN = mxGetN(VARIANCE_IN);
	
	ftolPr = mxGetPr(FTOL_IN);

    itMaxPr = mxGetPr(ITMAX_IN);

	coefPr = mxGetPr(P_COEFFG_IN);
	coefM = mxGetM(P_COEFFG_IN);
	coefN = mxGetN(P_COEFFG_IN);
	
	womM = mxGetM(WOM_IN);
	womPr = mxGetPr(WOM_IN);
	
	nom = mxGetM(OM_IN)*mxGetN(OM_IN);
	omPr = mxGetPr(OM_IN);

	kd2Pr = mxGetPr(KD2_IN);
	
	pldfvPr = mxGetPr(PLDFVV_IN);
	pldfvPi = mxGetPi(PLDFVV_IN);
	

/* Create output arguments */

	AA_OUT = mxCreateFull(ns, aaN, REAL);									/* Fitted parameters */
	CHI2_OUT = mxCreateFull(1,1, REAL);
	ITS_OUT = mxCreateFull(1,1, REAL);
	ALPHA_OUT = mxCreateFull(5, 5, REAL);									/* Covariance matrix of the result */

/* Deal with the output arguments */
		
	aaOutPr = mxGetPr(AA_OUT);
	chi2Pr = mxGetPr(CHI2_OUT);
	itsPr = mxGetPr(ITS_OUT);
	alphaPr = mxGetPr(ALPHA_OUT);


/* Do the actual calculation */
	MrqmndiagCalc(ns,aaN,aaPr,ymPr,variancePr,varianceM,varianceN,ftolPr,itMaxPr,
				  coefPr,coefM,coefN,womM,womPr,kd2Pr,nom,omPr,aaOutPr,chi2Pr,itsPr,
				  alphaPr,pldfvPr,pldfvPi);
	
}

