# include <stdlib.h>
# include <stdio.h>
# include <math.h>
# include "mex.h"


#define	max(A, B)	((A) > (B) ? (A) : (B))
#define	min(A, B)	((A) < (B) ? (A) : (B))
#define ddabs(A) ((A)<(0) ? (-A) : (A))
#define IND(k1,k2,N) (k1*N - ((k1+2)*(k1-1))/2L + k2-1)			/* Index of right triangular matrix */
#define IND2(k1,k2,N) ((k1+N*k2))								/* Index of regular matrix */


#ifdef ANSI_C
	extern void DirtheCalc(long ns,long aaN,double *aaPr,double *coefPr,long womM,double *womPr,double *kd2Pr,long nom,double *omPr,double *pldfvPr,double *pldfvPi,double *acfPr);
#else
	extern void DirtheCalc();
#endif

#ifdef ANSI_C
	MrqmndiagCalc(long ns,long aaN,double *aPr,double* ymPr, double *variancePr,long varianceM,long varianceN, 
	 			  double* ftolPr, double *itMaxPr,double *coefPr,long coefM,long coefN,
				  long womM,double *womPr,double *kd2Pr,long nom,double *omPr, 
				  double *aaOutPr,double *chi2Pr,double *itsPr,double *alphaPr,double *pldfvPr,double *pldfvPi)
#else
	MrqmndiagCalc(ns,aaN,aPr,ymPr,variancePr,varianceM,varianceN,ftolPr,itMaxPr,coefPr,coefM,coefN,womM,womPr,kd2Pr,nom,omPr,aaOutPr, chi2Pr, itsPr,alphaPr,pldfvPr,pldfvPi)
		long ns,aaN, varianceM, varianceN, coefM, coefN, womM, nom;
		double *aPr,*ymPr, *variancePr, *ftolPr, *itMaxPr, *coefPr, *womPr, *kd2Pr, *omPr, *aaOutPr, *chi2Pr, *itsPr, *alphaPr,*pldfvPr,*pldfvPi;
#endif
	{
	unsigned long i,j;
	Matrix *ya,*dyda,*aa2,*tempYa,*R,*Y,*KhiSqr,*dA,*chi2Old,*yaOld,*aaOld,*tempDyda, *errorBar;
	double *yaPr,*dydaPr,*aa2Pr,*tempYaPr,*RPr,*YPr,*KhiSqrPr,*dAPr,*chi2OldPr,*yaOldPr,*aaOldPr;
	double *tempDydaPr,*errorBarPr;
	double lambda = 0.001,maxDeviation;
	long validDer = 0,its = 0,itMax,*indicesVector;
	unsigned long nion = 2;
	Matrix *storage;
	
/* Get the max number of iterations from the matrix */

	itMax = (long)itMaxPr[0];

	storage = mxCreateFull(0, 0, REAL);		/* Do not save the angles in GULIPS_addm*/				

/* Copy a into aaOut */

	for(i=0;i<6;i++)
		aaOutPr[i] = aPr[i];

	aaOld = mxCreateFull(1, 5, REAL);
	aaOldPr = mxGetPr(aaOld);
		
	
	chi2Old=mxCreateFull(1,1,REAL);
	chi2OldPr=mxGetPr(chi2Old);
	
/* Create matrices ya and yaOld and call Dirthe */
	
	ya = mxCreateFull((coefM + 5), coefN, REAL);
	yaPr = mxGetPr(ya);
	
	yaOld = mxCreateFull((coefM + 5), coefN, REAL);
	yaOldPr = mxGetPr(yaOld);
	
	DirtheCalc(ns,aaN,aaOutPr,coefPr,womM,womPr,kd2Pr,nom,omPr,pldfvPr,pldfvPi,yaPr);
	
/* Create dyda and the temporaty copy of dyda matrix for the spectrum derivatives */

	dyda = mxCreateFull((coefM + 5),5, REAL);
	dydaPr = mxGetPr(dyda);
	
	tempDyda = mxCreateFull((coefM + 5),5, REAL);
	tempDydaPr = mxGetPr(tempDyda);

	chi2Pr[0] = 0;
	for (i=0;i<((coefM + 5)*coefN);i++)
		chi2Pr[0] += (ymPr[i]-yaPr[i])*(ymPr[i]-yaPr[i])/variancePr[i];
	
	/* Copy the sqrt(variance) to the errorbar (for the GULIPS) */ 

	errorBar = mxCreateFull(varianceM,varianceN,REAL);
	errorBarPr = mxGetPr(errorBar);
	
	for(i=0;i<(varianceM*varianceN);i++)
		errorBarPr[i] = sqrt(variancePr[i]);
		
	aa2 = mxCreateFull(1,5,REAL);
	aa2Pr = mxGetPr(aa2);
	
	tempYa = mxCreateFull((coefM + 5), coefN, REAL);
	tempYaPr = mxGetPr(tempYa);
	
	R = mxCreateFull(15,1,REAL);				/* Note: this is right triangular matrix!!! */
	RPr = mxGetPr(R);
	
	Y = mxCreateFull(5,1,REAL);					/* Note: this is number of unknowns (m) times 1) */
	YPr = mxGetPr(Y);
	
	KhiSqr = mxCreateFull(1,1,REAL);
	KhiSqrPr = mxGetPr(KhiSqr);
	
	dA = mxCreateFull(1,5,REAL);				/* Matrix for the solution of the inverse problem */
	dAPr = mxGetPr(dA);

	indicesVector = mex_calloc(5,sizeof(long));
	for(i=0;i<5;i++)
		indicesVector[i] = i;

	
/* The actual fitting loop */
	while(its<itMax)
		{
		if(!validDer)
			{
			its++;
			for(i=0;i<5;i++)					
				{
			
				/*Copy aaOut into aa2*/
				
				for(j=0;j<6;j++)
					aa2Pr[j] = aaOutPr[j];
				
				/* Change one of the parameters... */
				
				aa2Pr[i] += 0.0001;
				
				/* ...and calculate the derivatives using DirtheCalc 
				      and one loop which calculates the erotusosamr*/
				
				DirtheCalc(ns,aaN,aa2Pr,coefPr,womM,womPr,kd2Pr,nom,omPr,pldfvPr,pldfvPi,tempYaPr);

				for(j=0;j<(coefM + 5);j++)
					dydaPr[IND2(j,i,(coefM + 5))] = ((yaPr[j]-tempYaPr[j])/0.0001);
				}
			}
					
		
		/*Initialise R matrix */

		
		for(i=0;i<15;i++)
			RPr[i]=0;
		
		/*Put sqrt(lambda) in the diagonal elements of R*/
		
		for(i=0;i<5;i++)
			RPr[IND(i,i,5)]= sqrt(lambda);
		
		/*Initialise Y matrix */
		
		for(i=0;i<5;i++)
			YPr[i]=0;
		
		/* Initialise KhiSqr */
		KhiSqrPr[0]=0;

		for(i=0;i<((coefM + 5)*5);i++)
			tempDydaPr[i]=dydaPr[i];
			
		/* Calculate ya-ym (DirtheCalculated measumenets - real measurements)*/ 
		 for(i=0;i<(coefM + 5);i++)
		 	tempYaPr[i] = (yaPr[i]-ymPr[i]);

		/* Calculate the solution using GULIPS */
		GULIPS_addmCalc(RPr,YPr,tempDydaPr,tempYaPr,KhiSqrPr,(coefM + 5),5,1,storage,errorBarPr);
		GULIPS_invRCalc(RPr,5);
		GULIPS_mulCalc(RPr,YPr,dAPr,1,5);
		GULIPS_covCalc(RPr,indicesVector,5,1,5,alphaPr);

		/* Store old values chi2, ya and aa*/
		chi2OldPr[0] = chi2Pr[0];
	 	for(i=0;i<(coefM + 5);i++)
			yaOldPr[i] = yaPr[i];
		for(i=0;i<6;i++)
			aaOldPr[i] = aaOutPr[i];
		
		for(i=0;i<5;i++)
			aaOutPr[i] += dAPr[i];
		DirtheCalc(ns,aaN,aaOutPr,coefPr,womM,womPr,kd2Pr,nom,omPr,pldfvPr,pldfvPi,yaPr);
		chi2Pr[0] = 0;
		for(i=0;i<((coefM + 5)*coefN);i++)
			chi2Pr[0] += (ymPr[i]-yaPr[i])*(ymPr[i]-yaPr[i])/variancePr[i];

		maxDeviation = 0;
		for(i=0;i<5;i++)
			maxDeviation = max(ddabs(dAPr[i]),maxDeviation);

		if(chi2Pr[0]>=chi2OldPr[0])
			{
			chi2Pr[0] = chi2OldPr[0];
			for(i=0;i<(coefM + 5);i++)
				yaPr[i] = yaOldPr[i];
			for(i=0;i<6;i++)
				aaOutPr[i] = aaOldPr[i];
			lambda *= 10;
			validDer = 1;
				if(maxDeviation < ftolPr[0])
				{
				itsPr[0] = its;
				return;
				}
			}
		else
			{
			lambda /= 10;
			validDer = 0;
			if(maxDeviation < ftolPr[0])
				{
				itsPr[0] = its;
				return;
				}
			}
		}
	itsPr[0] = its;
	}

