# include <stdlib.h>
# include <stdio.h>
# include <math.h>
# include "mex.h"

#define ddabs(A) ((A)<(0) ? (-A) : (A))


/* Output Arguments */
#define	NIN0_OUT	plhs[0]
#define	TIT0_OUT	plhs[1]
#define	MIM0_OUT	plhs[2]
#define	PSI_OUT	plhs[3]
#define	VI_OUT	plhs[4]

/* Input Arguments */

#define	P_IN	prhs[0]


#ifdef MAC
	extern long ffloor(double x);
#endif

#ifdef ANSI_C
	extern void Transf(long ns,double *pPr,double *nin0Pr,double
*tit0Pr,double *mim0Pr,double *psiPr,double *viPr);
#else
	extern void Transf();
#endif



#ifdef ANSI_C
	void mexFunction(int nlhs, Matrix *plhs[], int nrhs, Matrix *prhs[])
#else
	mexFunction(nlhs, plhs, nrhs, prhs)
	int nlhs, nrhs;
	Matrix *plhs[], *prhs[];
#endif
{
	unsigned long ns,nion = 2;
	double *pPr, *nin0Pr,*tit0Pr,*mim0Pr,*psiPr,*viPr;
	

/* First check that we get the proper number of input & output arguments */

	if (nrhs != 1)
		mexErrMsgTxt("Transf requires one input argument.");
	if (nlhs != 5)
		mexErrMsgTxt("Transf requires five output arguments.");
	
/* Then get the pointers to the data part of the matrices */
	ns = mxGetM(P_IN);								/* Number of spectra */
	pPr = mxGetPr(P_IN);
	
	NIN0_OUT = mxCreateFull(ns, nion+1, REAL);
	TIT0_OUT = mxCreateFull(ns, nion+1, REAL);
	MIM0_OUT = mxCreateFull(ns, nion+1, REAL);
	PSI_OUT = mxCreateFull(ns, nion+1, REAL);
	VI_OUT = mxCreateFull(ns, nion+1, REAL);

	nin0Pr = mxGetPr(NIN0_OUT);
	tit0Pr = mxGetPr(TIT0_OUT);
	mim0Pr = mxGetPr(MIM0_OUT);
	psiPr = mxGetPr(PSI_OUT);
	viPr = mxGetPr(VI_OUT);

	
	Transf(ns,pPr,nin0Pr,tit0Pr,mim0Pr,psiPr,viPr);

}
