global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root

    set driver_tmp(${root}.dir_entry) ${base}.dir_entry
    set driver_tmp(${root}.source_browse) ${base}.source_browse
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }

    source_getlr_source $root
}

proc source_getlr_source { root } {

global driver_tmp
    if { $driver_tmp(${root}.source_radio) == 1 || $driver_tmp(${root}.source_radio) == 2 } {
	$driver_tmp(${root}.dir_entry) configure -state normal
	$driver_tmp(${root}.source_browse) configure -state normal
    } else {
	$driver_tmp(${root}.dir_entry) configure -state disabled
	$driver_tmp(${root}.source_browse) configure -state disabled
    }

}


proc source_getlr_getdir { } {
global driver_tmp

    if { $driver_tmp(${root}.source_radio) == 1 } {
	set driver_tmp(${root}.dir) [file dirname [tk_getOpenFile -title "Select a file in the source directory"]]
    }
    elseif { $driver_tmp(${root}.source_radio) == 2 } {
	set driver_tmp(${root}.dir) [tk_getOpenFile -title "Select the source file."]
    }
}


proc source_getlr_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc source_getlr_save { root file } {

global driver_data

    if { $driver_data(${root}.start) != "" } {
	if { [catch {clock scan $driver_data(${root}.start)} error] } {
	    error_message "$error\nfor \"source getlr\""
	    return 1
	}
    }
    
    if { $driver_data(${root}.dir) == "" } {
	error_message "No directory selected for \"source getlr\""
	return 1
    }

    puts $file "source getlr {"
    puts $file "    directory $driver_data(${root}.dir);"
    if { $driver_data(${root}.start) != "" }  {
	puts $file "    start $driver_data(${root}.start);"
    }
    if { $driver_data(${root}.t) || \
	    $driver_data(${root}.k) || $driver_data(${root}.s) || \
	    $driver_data(${root}.v) } {
	puts -nonewline $file "site"
	if { $driver_data(${root}.t) } { puts -nonewline $file " Tromso" }
	if { $driver_data(${root}.k) } { puts -nonewline $file " Kiruna" }
	if { $driver_data(${root}.s) } { puts -nonewline $file " Sodankyla" }
	if { $driver_data(${root}.v) } { puts -nonewline $file " VHF" }
	puts $file ";"
    }
    puts $file "}"
    
    return 0
}

proc source_getlr_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.start) != "" } {
	if { [catch {clock scan $driver_tmp(${root}.start)} error] } {
	    error_message $error
	    return
	}
    }
    
    if { $driver_tmp(${root}.dir) == "" } {
	error_message "No directory selected"
	return
    }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_source_needs_save 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc source_getlr_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)




