global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc source_isr_xdr_file_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc source_isr_xdr_file_save { root file } {

global driver_data

    if { $driver_data(${root}.start) != "" } {
	if { [catch {clock scan $driver_data(${root}.start)} error] } {
	    error_message "$error\nfor \"source isr xdr file\""
	    return 1
	}
    }
    
    if { $driver_data(${root}.file) == "" } {
	error_message "No file selected for \"source isr xdr file\""
	return 1
    }

    puts $file "source isr xdr file {"
    puts $file "    file $driver_data(${root}.file);"
    if { $driver_data(${root}.start) != "" }  {
	puts $file "    start $driver_data(${root}.start);"
    }
    puts $file "}"
    
    return 0
}

proc source_isr_xdr_file_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.start) != "" } {
	if { [catch {clock scan $driver_tmp(${root}.start)} error] } {
	    error_message $error
	    return
	}
    }
    
    if { $driver_tmp(${root}.file) == "" } {
	error_message "No file selected"
	return
    }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_source_needs_save 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc source_isr_xdr_file_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)


