proc add_source_driver { driver } {

global source_selected
global driver_path
global interface_path
global widgets
global source_needs_save
global LIBDIR

    if { $source_selected != "" && $source_selected != $driver } {
	if { [choice_message {"Yes" "No"} "Do you want to change the source from\n" "\"[lindex $source_selected 0]\" to \"$driver\"?"] != "Yes" } {
	    return -1
	}
	set source_needs_save 1
	catch {destroy [lindex $source_selected 1]}
    }
    
    foreach name [array names driver_tmp ".source*"] {
	unset driver_tmp($name)
    }
    foreach name [array names driver_data ".source*"] {
	unset driver_data($name)
    }
    

    # convert spaces in the driver name to _
    set translit_driver [translit " " "_" $driver]
    set root .${translit_driver}
    
    
    # if the command to display the dialog box for the current
    # driver is already installed then just run it
    # it may be installed in its own name, or with a _ui
    # appended if the interface was created with specTcl.
    #
    # if the command does not exists then look for a tcl source
    # file either in the current directory or in the driver
    # install directory which contains the code for the
    # driver interface.
    
    if { [llength [info commands ${translit_driver}]] == 1 || \
         [llength [info commands ${translit_driver}_ui]] == 1 } {
    } elseif { [file exists ${translit_driver}.tcl] } {
	source ${translit_driver}.tcl
    } elseif { [file exists ${translit_driver}.ui.tcl] } {
	source ${translit_driver}.ui.tcl

    } elseif { [file exists ${interface_path}/${translit_driver}.tcl] } {
	source ${interface_path}/${translit_driver}.tcl
    } elseif { [file exists ${interface_path}/${translit_driver}.ui.tcl] } {
	source ${interface_path}/${translit_driver}.ui.tcl

    } elseif { [file exists ${driver_path}/${translit_driver}.tcl] } {
	source ${driver_path}/${translit_driver}.tcl
    } elseif { [file exists ${driver_path}/${translit_driver}.ui.tcl] } {
	source ${driver_path}/${translit_driver}.ui.tcl

    } elseif { [file exists ${LIBDIR}/${translit_driver}.tcl] } {
	source ${LIBDIR}/${translit_driver}.tcl
    } elseif { [file exists ${LIBDIR}/${translit_driver}.ui.tcl] } {
	source ${LIBDIR}/${translit_driver}.ui.tcl

    } else {
	error_message "Unable to locate interface specification file\n" "for driver \"$driver\""
	status_message " No configuration driver for \"$driver\""
	return -1
    }

    $widgets(source_button) configure -text $driver -relief raised \
    	-activebackground #ececec -command "configure_driver \"$driver\" $root" \
    	-state normal
    
    set source_selected [list $driver $root]
    configure_driver "$driver" $root
    
    return 0
}
