proc configure_driver { driver root } {

global driver_path


    # convert spaces in the driver name to _
    set translit_driver [translit " " "_" $driver]
    
    # create the toplevel window (ie. the dialog)
    if { [winfo exists $root] } {
	raise ${root}
	return
    } else {
	toplevel $root 
	wm sizefrom ${root} program
	wm title ${root} "$driver"
    }
    
    
    # if the command to display the dialog box for the current
    # driver is already installed then just run it
    # it may be installed in its own name, or with a _ui
    # appended if the interface was created with specTcl.
    #
    # if the command does not exists then look for a tcl source
    # file either in the current directory or in the driver
    # install directory which contains the code for the
    # driver interface.
    
    if { [llength [info commands ${translit_driver}]] == 1 } {
	${translit_driver} ${root}
    } elseif { [llength [info commands ${translit_driver}_ui]] == 1 } {
	${translit_driver}_ui ${root}
    } else {
	destroy ${root}
	error_message "No configuration driver loaded for $driver"
	status_line "No configuration driver loaded for $driver"
    }
    
}
