proc delete_driver { driver root } {


global drivers_selected
global driver_extension
global strategy_needs_save
global driver_tmp
global widgets

    # convert spaces in the driver name to _
    set translit_driver [translit " " "_" $driver]

    set index [lsearch -glob $drivers_selected [list $driver $root *]]
    set driver_info [lindex $drivers_selected $index]

    if { [choice_message {Yes No} "Really delete driver \"$driver\?"] == "Yes" } {
	if { [winfo exists $root] } {
	    catch {destroy $root}
	}
	
	foreach name [array names driver_tmp "${root}.*"] {
	    unset driver_tmp($name)
	}
	foreach name [array names driver_data "${root}.*"] {
	    unset driver_data($name)
	}
	
	set drivers_selected [lreplace $drivers_selected $index $index]
	
	set ndrivers [llength $drivers_selected]

	set gridsize [grid size $widgets(driver_frame)]
	set ncolumns [lindex $gridsize 0]
	set nrows [lindex $gridsize 1]
    
	set move $index
	set button_name [lindex $driver_info 2]
	set grid_info [grid info $button_name]
	
	# the indices of the -row and -column entries in grid_info
	set row_index [lsearch -exact $grid_info -row]
	set column_index [lsearch -exact $grid_info -column]

	# set the location we want to move from
	# the row and column immediately follow -row and -column in grid_info
	if { $row_index > -1 && $column_index > -1 } {
	    set from_row [lindex $grid_info [expr $row_index +1]]
	    set from_column [expr [lindex $grid_info [expr $column_index +1]] +1]
	} else {
	    set from_column [expr $move +2]
	    set from_row 1
	}
	while { $from_column > 6 } {
	    incr from_row 1
	    incr from_column -6
	}

	# set the location we want to move to
	set to_column [expr $from_column -1]
	set to_row $from_row
	if { $to_column < 1 } {
	    incr to_row -1
	    set to_column 6
	}

	# remove the deleted button
	grid forget $button_name
	catch {destroy $button_name}
	
	while { $move < $ndrivers } {
	    # get the slave at the "from" position and move
	    # it "to" the to position
	    set slave [grid slaves $widgets(driver_frame) -row $from_row -column $from_column]
	    grid remove $slave
	    grid $slave -in $widgets(driver_frame) -row $to_row -column $to_column -sticky w

	    incr move 1

	    set to_column $from_column
	    set to_row $from_row

	    incr from_column 1
	    if { $from_column > 6 } {
		incr from_row 1
		set from_column 1
	    }

	}
    }    
}
