# interface generated by SpecTcl version 1.0 from /esrsw/uk/src/pi/Utilities/StrategyEditor/filter_site.ui
#   root     is the parent window for this user interface

proc filter_site_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 3 \
		-relief ridge

	frame $base.frame#5 \
		-borderwidth 2

	frame $base.frame#6 \
		-borderwidth 2 \
		-relief raised

	checkbutton $base.checkbutton#2 \
		-text ESR \
		-variable "driver_tmp($root.esr)"

	checkbutton $base.checkbutton#3 \
		-text Tromso \
		-variable "driver_tmp($root.tromso)"

	checkbutton $base.checkbutton#4 \
		-text Kiruna \
		-variable "driver_tmp($root.kiruna)"

	checkbutton $base.checkbutton#5 \
		-text Sodankyla \
		-variable "driver_tmp($root.sodankyla)"

	checkbutton $base.checkbutton#6 \
		-text VHF \
		-variable "driver_tmp($root.vhf)"

	checkbutton $base.checkbutton#7 \
		-text Millstone \
		-variable "driver_tmp($root.millstone)"

	button $base.button#2 \
		-command "filter_site_ok $root" \
		-text OK

	button $base.button#3 \
		-command "filter_site_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 3 -column 1  \
		-sticky ew
	grid $base.frame#6 -in $base.frame#1	-row 1 -column 1  \
		-sticky ew
	grid $base.checkbutton#2 -in $base.frame#6	-row 1 -column 1 
	grid $base.checkbutton#3 -in $base.frame#6	-row 1 -column 2 
	grid $base.checkbutton#4 -in $base.frame#6	-row 1 -column 3 
	grid $base.checkbutton#5 -in $base.frame#6	-row 1 -column 4 
	grid $base.checkbutton#6 -in $base.frame#6	-row 1 -column 5 
	grid $base.checkbutton#7 -in $base.frame#6	-row 1 -column 6 
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#6 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#6 2 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 3 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 4 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 5 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 6 -weight 0 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 1 -minsize 20
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc filter_site_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc filter_site_save { root file } {

global driver_data

    puts $file "filter site {"
    puts -nonewline $file "site"
    if { $driver_data(${root}.esr) } { puts -nonewline $file " ESR" }
    if { $driver_data(${root}.tromso) } { puts -nonewline $file " Tromso" }
    if { $driver_data(${root}.kiruna) } { puts -nonewline $file " Kiruna" }
    if { $driver_data(${root}.sodankyla) } { puts -nonewline $file " Sodankyla" }
    if { $driver_data(${root}.vhf) } { puts -nonewline $file " VHF" }
    puts $file ";"
    puts $file "}"
    
    return 0
}

proc filter_site_ok { root } {

global driver_data
global driver_tmp
    
    catch { regexp \[0-9\]+\$ $root driver_number }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_strategy_needs_save $driver_number 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc filter_site_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)





# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing filter_site"
	filter_site_ui .
    }
}
