# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/esr/Utilities/StrategyEditor/filter_time.ui
#   root     is the parent window for this user interface

proc filter_time_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 3 \
		-relief ridge

	frame $base.frame#7 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#4 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#5 \
		-borderwidth 2

	label $base.start_label \
		-text {start time}

	entry $base.start_entry \
		-textvariable "driver_tmp($root.start)"

	label $base.label#3 \
		-text {  end time}

	entry $base.end_entry \
		-textvariable "driver_tmp($root.end)"

	button $base.button#2 \
		-command "filter_time_ok $root" \
		-text OK

	button $base.button#3 \
		-command "filter_time_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#7 -in $base.frame#1	-row 3 -column 1  \
		-sticky ew
	grid $base.frame#4 -in $base.frame#1	-row 1 -column 1  \
		-ipady 2 \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 5 -column 1  \
		-sticky ew
	grid $base.start_label -in $base.frame#4	-row 1 -column 1  \
		-sticky e
	grid $base.start_entry -in $base.frame#4	-row 1 -column 2  \
		-sticky ew
	grid $base.label#3 -in $base.frame#7	-row 1 -column 1  \
		-sticky w
	grid $base.end_entry -in $base.frame#7	-row 1 -column 2 
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#7 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#7 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#7 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 2 -weight 1 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 0 -minsize 2
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 4 -weight 1 -minsize 20
	grid rowconfigure $base.frame#1 5 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc filter_time_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc filter_time_save { root file } {

global driver_data

    if { $driver_data(${root}.start) != "" } {
	if { [catch {clock scan $driver_data(${root}.start)} error] } {
	    error_message "$error\nfor \"filter time\""
	    return 1
	}
    }
    
    if { $driver_data(${root}.end) != "" } {
	if { [catch {clock scan $driver_data(${root}.end)} error] } {
	    error_message "$error\nfor \"filter time\""
	    return 1
	}
    }
    
    puts $file "filter time {"
    if { $driver_data(${root}.start) != "" }  {
	puts $file "    start $driver_data(${root}.start);"
    }
    if { $driver_data(${root}.end) != "" }  {
	puts $file "    end $driver_data(${root}.end);"
    }
    puts $file "}"
    
    return 0
}

proc filter_time_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.start) != "" } {
	if { [catch {clock scan $driver_tmp(${root}.start)} error] } {
	    error_message $error
	    return
	}
    }
    
    if { $driver_tmp(${root}.end) != "" } {
	if { [catch {clock scan $driver_tmp(${root}.end)} error] } {
	    error_message $error
	    return
	}
    }
    
    catch { regexp \[0-9\]+\$ $root driver_number }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_strategy_needs_save $driver_number 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc filter_time_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)



# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing filter_time"
	filter_time_ui .
    }
}
