proc insert_driver { root } {

global drivers_selected
global widgets
global driver_extension

    set ndrivers [llength $drivers_selected]

    set gridsize [grid size $widgets(driver_frame)]
    set ncolumns [lindex $gridsize 0]
    set nrows [lindex $gridsize 1]
    
    set location [lsearch -glob $drivers_selected "*${root}*"]

    set move $ndrivers

    # set the location we want to move to
    set to_column [expr $move +2]
    set to_row 1
    while { $to_column > 6 } {
	incr to_row 1
	incr to_column -6
    }

    # set the location we want to move from
    set from_column [expr $move +1]
    set from_row 1
    while { $from_column > 6 } {
	incr from_row 1
	incr from_column -6
    }

    # if the destination is to a new row or column, create a different
    # expanding row/column
    if { $to_row >= [expr $nrows -1] } {
	grid rowconfigure $widgets(driver_frame) $nrows -minsize 0 -weight 1 -pad 1
    }
    if { $to_column >= [expr $ncolumns -1] } {
	grid columnconfigure $widgets(driver_frame) $ncolumns -weight 1 -minsize 0 -pad 1
    }

    while { $move > $location } {
	
	# get the slave at the "from" position and move
	# it "to" the to position
	set slave [grid slaves $widgets(driver_frame) -row $from_row -column $from_column]
	grid remove $slave
	grid $slave -in $widgets(driver_frame) -row $to_row -column $to_column -sticky w
	
	incr move -1
	
	set to_column $from_column
	set to_row $from_row

	incr from_column -1
	if { $from_column < 1 } {
	    incr from_row -1
	    set from_column 6
	}
	
    }

    set button_name $widgets(driver_frame).driver_button$driver_extension
    menubutton $button_name -text "blank" -relief flat \
    	-activebackground #ececec -menu $button_name.menu \
	-background grey -state disabled -padx 5 -pady 5

    grid $button_name -in $widgets(driver_frame) -row $to_row -column $to_column -sticky w

    # re-grid the driver_frame to allow room for the new button to expand
    grid rowconfigure $widgets(driver_frame) $to_row -minsize 30 -weight 0 -pad 1 
    grid columnconfigure $widgets(driver_frame) $to_column -weight 0 -minsize 30 -pad 1
        
    set drivers_selected [linsert $drivers_selected $location [list "insert" {} $button_name]]
    
    incr driver_extension
}
