# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/develop/Utilities/StrategyEditor/integrate_matrix.ui
#   root     is the parent window for this user interface

proc integrate_matrix_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#5 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#1

	checkbutton $base.checkbutton#4 \
		-text {calculate variances} \
		-variable "driver_tmp($root.var)"

	button $base.button#1 \
		-command "integrate_matrix_ok $root" \
		-text OK

	button $base.button#3 \
		-command "integrate_matrix_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#5 -in $root	-row 1 -column 1  \
		-sticky w
	grid $base.frame#1 -in $root	-row 3 -column 1  \
		-sticky ew
	grid $base.checkbutton#4 -in $base.frame#5	-row 1 -column 1  \
		-sticky w
	grid $base.button#1 -in $base.frame#1	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#1	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $root 1 -weight 1 -minsize 20
	grid rowconfigure $root 2 -weight 0 -minsize 25
	grid rowconfigure $root 3 -weight 0 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 2
	grid columnconfigure $base.frame#1 2 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}


proc integrate_matrix_set_values { root values } {
global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc integrate_matrix_save { root file } {

global driver_data
global driver_tmp

    puts $file "integrate matrix { "
    
    if { ! $driver_data(${root}.var) } {
	puts $file "    novariances;"
    }

    puts $file "}"
    
    return 0
}

proc integrate_matrix_ok { root } {


global driver_data
global driver_tmp
    

    catch { regexp \[0-9\]+\$ $root driver_number }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_strategy_needs_save $driver_number 1
	}
    }
    destroy $driver_data(${root}.root)

}

proc integrate_matrix_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)








# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing integrate_matrix"
	integrate_matrix_ui .
    }
}
