# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/develop/Utilities/StrategyEditor/integrate_move.ui
#   root     is the parent window for this user interface

proc integrate_move_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1

	frame $base.frame#6 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#5 \
		-borderwidth 2 \
		-relief raised

	checkbutton $base.checkbutton#4 \
		-text {calculate variances} \
		-variable "driver_tmp($root.var)"

	checkbutton $base.checkbutton#6 \
		-text {matrix data} \
		-variable "driver_tmp($root.matrix)"

	checkbutton $base.checkbutton#5 \
		-command "integrate_move_select_scan_file $root" \
		-text {output scan file} \
		-variable "driver_tmp($root.scan)"

	entry $base.file_entry \
		-cursor {} \
		-textvariable "driver_tmp($root.file)"

	button $base.browse_button \
		-command "set driver_tmp($root.file) \[tk_getSaveFile -title \"Select the output file\" -filetypes {{{Scan files} {.scan}} {{Any file} {*}}}\]" \
		-text Browse...

	button $base.button#1 \
		-command "integrate_move_ok $root" \
		-text OK

	button $base.button#3 \
		-command "integrate_move_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 5 -column 1  \
		-sticky ew
	grid $base.frame#6 -in $root	-row 3 -column 1  \
		-sticky ew
	grid $base.frame#5 -in $root	-row 1 -column 1  \
		-sticky w
	grid $base.checkbutton#4 -in $base.frame#5	-row 1 -column 1  \
		-sticky w
	grid $base.checkbutton#6 -in $base.frame#5	-row 1 -column 2 
	grid $base.checkbutton#5 -in $base.frame#6	-row 1 -column 1  \
		-sticky e
	grid $base.file_entry -in $base.frame#6	-row 1 -column 2  \
		-sticky ew
	grid $base.browse_button -in $base.frame#6	-row 1 -column 3  \
		-sticky e
	grid $base.button#1 -in $base.frame#1	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#1	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#6 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#6 1 -weight 0 -minsize 83
	grid columnconfigure $base.frame#6 2 -weight 1 -minsize 84
	grid columnconfigure $base.frame#6 3 -weight 0 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 20
	grid rowconfigure $root 2 -weight 0 -minsize 2
	grid rowconfigure $root 3 -weight 0 -minsize 30
	grid rowconfigure $root 4 -weight 0 -minsize 30
	grid rowconfigure $root 5 -weight 0 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#5 2 -weight 0 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 2
	grid columnconfigure $base.frame#1 2 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    set driver_tmp(${root}.file_entry) ${base}.file_entry
    set driver_tmp(${root}.browse_button) ${base}.browse_button
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
    integrate_move_select_scan_file $root
}

proc integrate_move_select_scan_file { root } {

global driver_tmp


    if { $driver_tmp(${root}.scan) } {
	$driver_tmp(${root}.file_entry) configure -state normal
	$driver_tmp(${root}.browse_button) configure -state normal
    } else {
	$driver_tmp(${root}.file_entry) configure -state disabled
	$driver_tmp(${root}.browse_button) configure -state disabled
    }
    
}

proc integrate_move_set_values { root values } {
global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc integrate_move_save { root file } {

global driver_data
global driver_tmp

    if { $driver_data(${root}.scan) && $driver_data(${root}.file) == "" } {
	error_message "No scan file selected for \"integrate move\""
	return 1
    }

    puts $file "integrate move { "
    
    if { $driver_data(${root}.scan) } {
	 puts $file "    scanfile $driver_data(${root}.file);"
    }
   
    if { ! $driver_data(${root}.var) } {
	puts $file "    novariances;"
    }

    if { $driver_data(${root}.matrix) } {
	puts $file "    matrix;"
    }

    puts $file "}"
    
    return 0
}

proc integrate_move_ok { root } {


global driver_data
global driver_tmp
    
    if { $driver_tmp(${root}.scan) && $driver_tmp(${root}.file) == "" } {
	error_message "No scan file selected for \"integrate move\""
	return
    }

    catch { regexp \[0-9\]+\$ $root driver_number }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_strategy_needs_save $driver_number 1
	}
    }
    destroy $driver_data(${root}.root)

}

proc integrate_move_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)








# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing integrate_move"
	integrate_move_ui .
    }
}
