# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/develop/Utilities/StrategyEditor/integrate_scanfile.ui
#   root     is the parent window for this user interface

proc integrate_scanfile_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#2

	frame $base.frame#1

	frame $base.frame#3 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#4 \
		-borderwidth 2 \
		-relief raised

	label $base.label#1 \
		-text {scanfile name}

	entry $base.entry#1 \
		-textvariable "driver_tmp($root.file)"

	button $base.button#3 \
		-command "set driver_tmp($root.file) \[tk_getOpenFile -title \"Select the scanfile\" -filetypes {{{Scan files} {.scan}} {{Any file} {*}}}\]" \
		-text Broswe...

	checkbutton $base.checkbutton#1 \
		-text {calculate variances} \
		-variable "driver_tmp($root.var)"

	checkbutton $base.checkbutton#3checkbutton#3 \
		-text {matrix data} \
		-variable "driver_tmp($root.matrix)"

	button $base.button#1 \
		-command "integrate_scanfile_ok $root" \
		-text OK

	button $base.button#2 \
		-command "integrate_scanfile_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#2 -in $root	-row 1 -column 1 
	grid $base.frame#1 -in $root	-row 3 -column 1  \
		-sticky ew
	grid $base.frame#3 -in $base.frame#2	-row 1 -column 1  \
		-sticky ew
	grid $base.frame#4 -in $base.frame#2	-row 3 -column 1  \
		-sticky w
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1 
	grid $base.entry#1 -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.button#3 -in $base.frame#3	-row 1 -column 3 
	grid $base.checkbutton#1 -in $base.frame#4	-row 1 -column 1 
	grid $base.checkbutton#3checkbutton#3 -in $base.frame#4	-row 1 -column 2 
	grid $base.button#1 -in $base.frame#1	-row 1 -column 1 
	grid $base.button#2 -in $base.frame#1	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#2 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#2 2 -weight 0 -minsize 2
	grid rowconfigure $base.frame#2 3 -weight 0 -minsize 30
	grid columnconfigure $base.frame#2 1 -weight 1 -minsize 45

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30
	grid columnconfigure $base.frame#3 3 -weight 0 -minsize 30

	grid rowconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 2 -weight 0 -minsize 30

	grid rowconfigure $root 1 -weight 0 -minsize 30
	grid rowconfigure $root 2 -weight 0 -minsize 17
	grid rowconfigure $root 3 -weight 0 -minsize 30
	grid columnconfigure $root 1 -weight 0 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 39
	grid columnconfigure $base.frame#1 2 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc integrate_scanfile_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc integrate_scanfile_save { root file } {

global driver_data

    if { $driver_data(${root}.file) == "" } {
	error_message "No scan file selected for \"integrate scanfile\""
	return 1
    }


    puts $file "integrate scanfile { "

    puts $file "    scanfile $driver_data(${root}.file);"
    
    if { ! $driver_data(${root}.var) } {
	puts $file "    novariances;"
    }
    if { $driver_data(${root}.matrix) } {
	puts $file "    matrix;"
    }
    puts $file "}"
    
    return 0
}

proc integrate_scanfile_ok { root } {

global driver_data
global driver_tmp
    
    if { $driver_tmp(${root}.file) == "" } {
	error_message "No scan file selected for \"integrate scanfile\""
	return
    }

    catch { regexp \[0-9\]+\$ $root driver_number }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_strategy_needs_save $driver_number 1
	}
    }
    destroy $driver_data(${root}.root)

}

proc integrate_scanfile_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)

# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing integrate_scanfile"
	integrate_scanfile_ui .
    }
}
