#! /bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"
# interface generated by SpecTcl version 1.1 from /ESRsoftware/PostIntegration/develop/Utilities/StrategyEditor/integrate_time.ui
#   root     is the parent window for this user interface

proc integrate_time_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#2

	frame $base.frame#1

	frame $base.frame#3 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#7 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#4 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#6 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#5 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#9 \
		-borderwidth 2 \
		-relief ridge

	frame $base.frame#8 \
		-borderwidth 2 \
		-relief ridge

	frame $base.frame#10

	frame $base.frame#12

	frame $base.frame#11

	label $base.label#1 \
		-text {integration period}

	entry $base.entry#1 \
		-textvariable "driver_tmp($root.period)"

	label $base.label#2 \
		-text start

	entry $base.entry#2 \
		-textvariable "driver_tmp($root.start)"

	checkbutton $base.checkbutton#4 \
		-command "integrate_time_skip_on $root" \
		-text {skip (after integration)} \
		-variable "driver_tmp($root.skip_on)"

	entry $base.skip_entry \
		-textvariable "driver_tmp($root.skip)" \
		-width 10

	checkbutton $base.checkbutton#5 \
		-command "integrate_time_step_on $root" \
		-text step \
		-variable "driver_tmp($root.step_on)"

	label $base.label#3

	radiobutton $base.fraction_radio \
		-text fraction \
		-value fraction \
		-variable "driver_tmp($root.step_radio)"

	menubutton $base.step_fraction_menu \
		-relief raised \
		-text menubutton \
		-textvariable "driver_tmp($root.step_fraction)"

	radiobutton $base.period_radio \
		-text period \
		-value period \
		-variable "driver_tmp($root.step_radio)"

	entry $base.step_period_entry \
		-textvariable "driver_tmp($root.step_period)"
	catch {
		$base.step_period_entry configure \
			-font -*-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*
	}

	checkbutton $base.checkbutton#1 \
		-text {calculate variances} \
		-variable "driver_tmp($root.var)"

	checkbutton $base.checkbutton#3 \
		-text {matrix data} \
		-variable "driver_tmp($root.matrix)"

	checkbutton $base.checkbutton#2 \
		-command "integrate_time_select_scan_file $root" \
		-text {output scan file} \
		-variable "driver_tmp($root.scan)"

	entry $base.file_entry \
		-textvariable "driver_tmp($root.file)"

	button $base.browse_button \
		-command "set driver_tmp($root.file) \[tk_getSaveFile -title \"Select the output file\" -filetypes {{{Scan files} {.scan}} {{Any file} {*}}}\]" \
		-text Browse...

	button $base.button#1 \
		-command "integrate_time_ok $root" \
		-text OK

	button $base.button#2 \
		-command "integrate_time_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#2 -in $root	-row 3 -column 1  \
		-sticky ew
	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#3 -in $base.frame#1	-row 1 -column 1  \
		-sticky ew
	grid $base.frame#7 -in $base.frame#1	-row 9 -column 1  \
		-sticky ew
	grid $base.frame#4 -in $base.frame#1	-row 3 -column 1  \
		-sticky ew
	grid $base.frame#6 -in $base.frame#1	-row 7 -column 1  \
		-sticky w
	grid $base.frame#5 -in $base.frame#1	-row 5 -column 1  \
		-sticky w
	grid $base.frame#9 -in $base.frame#5	-row 2 -column 1  \
		-sticky w
	grid $base.frame#8 -in $base.frame#5	-row 1 -column 1  \
		-sticky w
	grid $base.frame#10 -in $base.frame#9	-row 2 -column 1  \
		-sticky ew
	grid $base.frame#12 -in $base.frame#10	-row 2 -column 2  \
		-sticky ew
	grid $base.frame#11 -in $base.frame#10	-row 1 -column 2  \
		-sticky ew
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1 
	grid $base.entry#1 -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.label#2 -in $base.frame#4	-row 1 -column 1 
	grid $base.entry#2 -in $base.frame#4	-row 1 -column 2  \
		-sticky ew
	grid $base.checkbutton#4 -in $base.frame#8	-row 1 -column 1 
	grid $base.skip_entry -in $base.frame#8	-row 1 -column 2 
	grid $base.checkbutton#5 -in $base.frame#9	-row 1 -column 1  \
		-sticky w
	grid $base.label#3 -in $base.frame#10	-row 1 -column 1 
	grid $base.fraction_radio -in $base.frame#11	-row 1 -column 1 
	grid $base.step_fraction_menu -in $base.frame#11	-row 1 -column 2  \
		-sticky w
	grid $base.period_radio -in $base.frame#12	-row 1 -column 1 
	grid $base.step_period_entry -in $base.frame#12	-row 1 -column 2 
	grid $base.checkbutton#1 -in $base.frame#6	-row 1 -column 1  \
		-sticky w
	grid $base.checkbutton#3 -in $base.frame#6	-row 1 -column 2 
	grid $base.checkbutton#2 -in $base.frame#7	-row 1 -column 1  \
		-sticky w
	grid $base.file_entry -in $base.frame#7	-row 1 -column 2  \
		-sticky ew
	grid $base.browse_button -in $base.frame#7	-row 1 -column 3 
	grid $base.button#1 -in $base.frame#2	-row 1 -column 1 
	grid $base.button#2 -in $base.frame#2	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#2 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#2 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#2 2 -weight 1 -minsize 67

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#5 2 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#6 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#6 2 -weight 0 -minsize 30

	grid rowconfigure $base.frame#7 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#7 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#7 2 -weight 1 -minsize 30
	grid columnconfigure $base.frame#7 3 -weight 0 -minsize 30

	grid rowconfigure $root 1 -weight 0 -minsize 14
	grid rowconfigure $root 2 -weight 1 -minsize 5
	grid rowconfigure $root 3 -weight 0 -minsize 27
	grid columnconfigure $root 1 -weight 1 -minsize 160

	grid rowconfigure $base.frame#8 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#8 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#8 2 -weight 0 -minsize 30

	grid rowconfigure $base.frame#9 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#9 2 -weight 0 -minsize 30
	grid columnconfigure $base.frame#9 1 -weight 0 -minsize 30

	grid rowconfigure $base.frame#10 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#10 2 -weight 0 -minsize 30
	grid columnconfigure $base.frame#10 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#10 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#11 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#11 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#11 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#12 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#12 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#12 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 1 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 0 -minsize 2
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 4 -weight 0 -minsize 2
	grid rowconfigure $base.frame#1 5 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 6 -weight 0 -minsize 4
	grid rowconfigure $base.frame#1 7 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 8 -weight 0 -minsize 2
	grid rowconfigure $base.frame#1 9 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30
# additional interface code
    global driver_data
    global driver_tmp

    set driver_tmp(${root}.root) $root
    set driver_tmp(${root}.file_entry) ${base}.file_entry
    set driver_tmp(${root}.browse_button) ${base}.browse_button
    set driver_tmp(${root}.skip_entry) ${base}.skip_entry
    set driver_tmp(${root}.fraction_radio) ${base}.fraction_radio
    set driver_tmp(${root}.step_fraction_menu) ${base}.step_fraction_menu
    set driver_tmp(${root}.period_radio) ${base}.period_radio
    set driver_tmp(${root}.step_period_entry) ${base}.step_period_entry

    menu ${base}.step_fraction_menu.menu
    ${base}.step_fraction_menu configure -menu ${base}.step_fraction_menu.menu
    ${base}.step_fraction_menu.menu add command -label T/4 -command "set driver_tmp(${root}.step_fraction) T/4"
    ${base}.step_fraction_menu.menu add command -label T/2 -command "set driver_tmp(${root}.step_fraction) T/2"


    $driver_tmp(${root}.fraction_radio) configure -state disabled
    $driver_tmp(${root}.period_radio) configure -state disabled
    $driver_tmp(${root}.step_fraction_menu) configure -state disabled
    $driver_tmp(${root}.step_period_entry) configure -state disabled
    
    $driver_tmp(${root}.skip_entry) configure -state disabled

    if { $driver_tmp(${root}.step_fraction) == "menubutton" } {
	set driver_tmp(${root}.step_fraction) T/4
    }
    if { $driver_tmp(${root}.step_radio) == "" } {
	set driver_tmp(${root}.step_radio) fraction
    }

    if { $driver_tmp(${root}.step_on) } {
	integrate_time_step_on ${root} 
    }

    if { $driver_tmp(${root}.skip_on) } {
	integrate_time_skip_on ${root} 
    }

    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
    integrate_time_select_scan_file $root



}

proc integrate_time_select_scan_file { root } {

    global driver_tmp

    if { $driver_tmp(${root}.scan) } {
	$driver_tmp(${root}.file_entry) configure -state normal
	$driver_tmp(${root}.browse_button) configure -state normal
    } else {
	$driver_tmp(${root}.file_entry) configure -state disabled
	$driver_tmp(${root}.browse_button) configure -state disabled
    }
    
}

proc integrate_time_skip_on { root } {
    global driver_tmp

    set driver_tmp(${root}.step_on) 0
    
    $driver_tmp(${root}.fraction_radio) configure -state disabled
    $driver_tmp(${root}.period_radio) configure -state disabled
    $driver_tmp(${root}.step_fraction_menu) configure -state disabled
    $driver_tmp(${root}.step_period_entry) configure -state disabled
    
    $driver_tmp(${root}.skip_entry) configure -state normal
}

proc integrate_time_step_on { root } {
    global driver_tmp
    
    set driver_tmp(${root}.skip_on) 0
    
    $driver_tmp(${root}.fraction_radio) configure -state normal
    $driver_tmp(${root}.period_radio) configure -state normal
    $driver_tmp(${root}.step_fraction_menu) configure -state normal
    $driver_tmp(${root}.step_period_entry) configure -state normal
    
    $driver_tmp(${root}.skip_entry) configure -state disabled
}

proc integrate_time_set_values { root values } {
    
    global driver_data
    global driver_tmp
    
    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	if { $var == "step" } {
	    set driver_tmp(${root}.step_on) 1
	    set driver_data(${root}.step_on) 1
	    if { [regexp {^[Tt]/[0-9][0-9]*$} $val] } {
		set driver_tmp(${root}.step_radio) "fraction"
		set driver_tmp(${root}.step_fraction) $val
		set driver_data(${root}.step_radio) "fraction"
		set driver_data(${root}.step_fraction) $val
	    } else {
		set driver_tmp(${root}.step_radio) "period"
		set driver_tmp(${root}.step_period) $val
		set driver_data(${root}.step_radio) "period"
		set driver_data(${root}.step_period) $val
	    }
	} else {
	    if {$var == "skip" } {
		set driver_tmp(${root}.skip_on) 1
		set driver_data(${root}.skip_on) 1
	    }
	    set driver_tmp(${root}.${var}) $val
	    set driver_data(${root}.${var}) $val
	}
    }
}

proc integrate_time_save { root file } {
    
    global driver_data
    
    if { $driver_data(${root}.period) == "" } {
	error_message "No period selected for \"integrate time\""
	return 1
    }
    
    if { $driver_data(${root}.start) != "" } {
	if { [catch {clock scan $driver_data(${root}.start)} error] } {
	    error_message "Error in start time for \"integrate time\""
	    return 1
	}
    }
    
    if { $driver_data(${root}.scan) && $driver_data(${root}.file) == "" } {
	error_message "No scan file selected for \"integrate time\""
	return 1
    }
    
    puts $file "integrate time {"
    puts $file "    period $driver_data(${root}.period);"
    if { $driver_data(${root}.start) != "" } {
	puts $file "    start $driver_data(${root}.start);"
    }
    
    if { $driver_data(${root}.skip_on) } {
	if { $driver_data(${root}.skip) != "" } {
	    puts $file "    skip $driver_data(${root}.skip);"
	}
    }

    if { $driver_data(${root}.step_on) } {
	if { $driver_data(${root}.step_radio) == "period" } {
	    if { $driver_data(${root}.step_period) != "" } {
		puts $file "    step $driver_data(${root}.step_period);"
	    }
	} else {
	    puts $file "    step $driver_data(${root}.step_fraction);"
	}
    }

    if { ! $driver_data(${root}.var) } {
	puts $file "    novariances;"
    }
    
    if { $driver_data(${root}.matrix) } {
	puts $file "    matrix;"
    }
    
    if { $driver_data(${root}.scan) } {
	 puts $file "    scanfile $driver_data(${root}.file);"
    }
   
    puts $file "}"
    
    return 0
}


proc integrate_time_ok { root } {

    global driver_data
    global driver_tmp

    if { $driver_tmp(${root}.period) == "" } {
	error_message "No period selected"
	return
    }

    if { $driver_tmp(${root}.start) != "" } {
	if { [catch {clock scan $driver_tmp(${root}.start)} error] } {
	    error_message "Error in start time"
	    return
	}
    }
    
    if { $driver_tmp(${root}.skip_on) && $driver_tmp(${root}.skip) == "" } {
	error_message "No skip set"
	return
    }
    if { $driver_tmp(${root}.step_on) && $driver_tmp(${root}.step_radio) == "period" &&
	 $driver_tmp(${root}.step_period) == "" } {
	error_message "No step period set"
	return
    }

    if { $driver_tmp(${root}.scan) && $driver_tmp(${root}.file) == "" } {
	error_message "No scan file selected for \"integrate time\""
	return
    }

    catch { regexp \[0-9\]+\$ $root driver_number }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_strategy_needs_save $driver_number 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc integrate_time_cancel { root } {

    global driver_data
    global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)








# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if [info exists embed_args] {
	# we are running in the plugin
	integrate_time_ui .
    } else {
	# we are running in stand-alone mode
	if {$argv0 == [info script]} {
	    wm title . "Testing integrate_time_ui"
	    integrate_time_ui .
	}
    }
}
