# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/esr/Utilities/StrategyEditor/main_menu.ui
#   root     is the parent window for this user interface

proc main_menu_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.driver_frame \
		-background grey

	frame $base.frame#4 \
		-background grey \
		-borderwidth 2 \
		-relief raised

	menubutton $base.file_menu_button \
		-background grey \
		-menu "$base.file_menu_button.menu" \
		-text File

	menubutton $base.source_menu_button \
		-background grey \
		-menu "$base.source_menu_button.menu" \
		-text Source

	menubutton $base.filter_menu_button \
		-background grey \
		-menu "$base.filter_menu_button.menu" \
		-text Filter

	menubutton $base.integrate_menu_button \
		-background grey \
		-menu "$base.integrate_menu_button.menu" \
		-text Integrate

	menubutton $base.output_menu_button \
		-background grey \
		-menu "$base.output_menu_button.menu" \
		-text Output

	menubutton $base.other_menu_button \
		-background grey \
		-menu "$base.other_menu_button.menu" \
		-state disabled \
		-text Others

	menubutton $base.help_menu_button \
		-background grey \
		-text Help

	button $base.source_button \
		-activebackground grey \
		-background grey \
		-disabledforeground grey \
		-highlightbackground grey \
		-relief flat \
		-state disabled

	label $base.status_label \
		-anchor w \
		-justify left \
		-relief ridge \
		-text {Please select a source driver} \
		-textvariable status_message
	catch {
		$base.status_label configure \
			-font {-*-interface user-Bold-R-Normal-*-*-120-*-*-*-*-*-*}
	}


	# Geometry management

	grid $base.driver_frame -in $root	-row 2 -column 1  \
		-sticky nesw
	grid $base.frame#4 -in $root	-row 1 -column 1  \
		-sticky ew
	grid $base.file_menu_button -in $base.frame#4	-row 1 -column 1  \
		-sticky w
	grid $base.source_menu_button -in $base.frame#4	-row 1 -column 2  \
		-sticky w
	grid $base.filter_menu_button -in $base.frame#4	-row 1 -column 3  \
		-sticky w
	grid $base.integrate_menu_button -in $base.frame#4	-row 1 -column 4  \
		-sticky w
	grid $base.output_menu_button -in $base.frame#4	-row 1 -column 5  \
		-sticky w
	grid $base.other_menu_button -in $base.frame#4	-row 1 -column 6  \
		-sticky w
	grid $base.help_menu_button -in $base.frame#4	-row 1 -column 8  \
		-sticky e
	grid $base.source_button -in $base.driver_frame	-row 1 -column 1  \
		-sticky nw
	grid $base.status_label -in $root	-row 3 -column 1  \
		-sticky nesw

	# Resize behavior management

	grid rowconfigure $base.driver_frame 1 -weight 0 -minsize 30
	grid rowconfigure $base.driver_frame 2 -weight 1 -minsize 30
	grid columnconfigure $base.driver_frame 1 -weight 0 -minsize 30
	grid columnconfigure $base.driver_frame 2 -weight 1 -minsize 30

	grid rowconfigure $root 1 -weight 0 -minsize 30
	grid rowconfigure $root 2 -weight 1 -minsize 145
	grid rowconfigure $root 3 -weight 0 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 300

	grid rowconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 1 -weight 0 -minsize 17
	grid columnconfigure $base.frame#4 2 -weight 0 -minsize 2
	grid columnconfigure $base.frame#4 3 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 4 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 5 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 6 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 7 -weight 1 -minsize 100
	grid columnconfigure $base.frame#4 8 -weight 0 -minsize 24
# additional interface code
global widgets

    set widgets(base) $base
    set widgets(file_menu) [menu $base.file_menu_button.menu]
    $widgets(file_menu) add command -label {Driver Path...} -command {set_driver_path}
    $widgets(file_menu) add separator
    $widgets(file_menu) add command -label {Open Source...} -command {open_source}
    $widgets(file_menu) add command -label {Open Strategy...} -command {open_strategy}
    $widgets(file_menu) add separator
    $widgets(file_menu) add command -label {Save Source} -command {save_source}
    $widgets(file_menu) add command -label {Save Strategy} -command {save_strategy}
    $widgets(file_menu) add command -label {Save Source As...} -command {save_source_as}
    $widgets(file_menu) add command -label {Save Strategy As...} -command {save_strategy_as}
    $widgets(file_menu) add separator
    $widgets(file_menu) add command -label {Test...} -command {test_strategy}
    $widgets(file_menu) add command -label {Run...} -command {run_integration_dialog}
    $widgets(file_menu) add separator
    $widgets(file_menu) add command -label {Exit} -command {exit_editor}

    set widgets(source_menu) [menu $base.source_menu_button.menu]
    set widgets(filter_menu) [menu $base.filter_menu_button.menu]
    set widgets(integrate_menu) [menu $base.integrate_menu_button.menu]
    set widgets(output_menu) [menu $base.output_menu_button.menu]
    set widgets(other_menu) [menu $base.other_menu_button.menu]
    set widgets(other_menu_button) $base.other_menu_button
    
    set widgets(driver_frame) $base.driver_frame
    
    set widgets(source_button) $base.source_button    

# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing main_menu"
	main_menu_ui .
    }
}
