# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/develop/Utilities/StrategyEditor/output_gup.ui
#   root     is the parent window for this user interface

proc output_gup_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 3 \
		-relief ridge

	frame $base.frame#3 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#5 \
		-borderwidth 2

	label $base.label#1 \
		-text Directory

	entry $base.entry#1 \
		-textvariable "driver_tmp($root.dir)"

	button $base.button#1 \
		-command "set driver_tmp($root.dir) \[file dirname \[tk_getOpenFile -title \"Select a file in the output directory\"\]\]" \
		-text Browse...

	button $base.button#2 \
		-command "output_gup_ok $root" \
		-text OK

	button $base.button#3 \
		-command "output_gup_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#3 -in $base.frame#1	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 3 -column 1  \
		-sticky ew
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1  \
		-sticky w
	grid $base.entry#1 -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.button#1 -in $base.frame#3	-row 1 -column 3  \
		-sticky e
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30
	grid columnconfigure $base.frame#3 3 -weight 0 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 0 -minsize 21
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root

    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
    
}

proc output_gup_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc output_gup_save { root file } {

global driver_data

    if { $driver_data(${root}.dir) == "" } {
	error_message "No directory selected for \"output gup\""
	return 1
    }

    puts $file "output gup {"
    puts $file "    directory $driver_data(${root}.dir);"
    puts $file "}"
    
    return 0
}


proc output_gup_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.dir) == "" } {
	error_message "No directory selected"
	return
    }
    
    catch { regexp \[0-9\]+\$ $root driver_number }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_strategy_needs_save $driver_number 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc output_gup_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)




# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing output_gup"
	output_gup_ui .
    }
}
