proc save_source { } {

global source_filename

    if { $source_filename == "" } {
	status_message "Choose a filename to save the source to..."
	set tmp_filename [tk_getSaveFile -title "Save As ..."  -filetypes {{{Source definition files} {.sdef}} {{Any file} {*}}}]
	if { $tmp_filename == "" } { 
	    status_message "Not saved"
	    return 1
	}
	set source_filename $tmp_filename
    }
    
    if { [save_source_file $source_filename 1] != 0 } {
	status_message "Failure during save"
	return 1
    }
    return 0
}

proc save_source_as { } {

global source_filename

    status_message "Choose a filename to save the source to..."
    set tmp_filename [tk_getSaveFile -title "Save As ..." -filetypes {{{source definition files} {.sdef}} {{any file} {*}}}]
    if { $tmp_filename == "" } { 
	status_message "Not saved"
	return 1
    }
    set source_filename $tmp_filename
    
    if { [save_source_file $source_filename 1] != 0 } {
	status_message "Failure during save"
	return 1
    }
    return 0
}

proc save_source_file { filename set_saved} {

global source_selected

    status_message "Saving $filename..."
    if { $source_selected == "" } {
	error_message "No source driver selected"
	return 1
    }

    set driver [lindex $source_selected 0]
    set root [lindex $source_selected 1]
    set translit_driver [translit " " "_" $driver]

    if { [info commands ${translit_driver}_save] == "" } {
	error_message "No save function for \n" "\"$driver\""
	status_message "Failure during save"
	return 1
    }

    set file [open $filename "w"]    

    # execute the save function in the source driver interface
    set save_failed [${translit_driver}_save ${root} $file]
    
    close $file

    if { $save_failed } {
	error_message "Failed to save $driver"
	return 1
    }
    
    # remove the flag indicating source requires saving.
    if { $set_saved } {
	set_source_saved
    }
    
    status_message "$filename saved"
    
    return 0
}
