proc save_strategy { } {

global strategy_filename

    if { $strategy_filename == "" } {
	status_message "Choose a filename to save the strategy to..."
	set tmp_filename [tk_getSaveFile -title "Save As ..." -filetypes {{{Strategy definition files} {.idef}} {{Any file} {*}}}]
	if { $tmp_filename == "" } { 
	    status_message "Not saved"
	    return 1
	}
	set strategy_filename $tmp_filename
    }
    
    if { [save_strategy_file $strategy_filename 1] != 0 } {
	status_message "Failure during save"
	return 1
    }
    return 0
}

proc save_strategy_as { } {

global strategy_filename

    status_message "Choose a filename to save the strategy to..."
    set tmp_filename [tk_getSaveFile -title "Save As ..." -filetypes {{{strategy definition files} {.idef}} {{any file} {*}}}]
    if { $tmp_filename == "" } { 
	status_message "Not saved"
	return 1
    }
    set strategy_filename $tmp_filename
    
    if { [save_strategy_file $strategy_filename 1] != 0 } {
	status_message "Failure during save"
	return 1
    }
    return 0
}

proc save_strategy_file { filename set_saved} {

global drivers_selected


    status_message "Saving $filename..."
    if { [llength $drivers_selected] == 0 } {
	error_message "No pipeline drivers selected"
	return 1
    }

    set file [open $filename "w"]    

    foreach driver $drivers_selected {
	set driver_name [lindex $driver 0]
	set root [lindex $driver 1]
	set translit_driver [translit " " "_" $driver_name]
	if { [info commands ${translit_driver}_save] == "" } {
	    error_message "No save function for\n" "\"$driver_name\""
	} else {
	    set save_failed [${translit_driver}_save ${root} $file]
	    if { $save_failed } {
		error_message "Failed to save $driver_name"
		break
	    }
	}
    }
    
    close $file
    
    if { $save_failed } {
	return 1
    }

    # remove the flag indicating strategy requires saving.
    if { $set_saved } {
	set_strategy_saved
    }
    
    status_message "$filename saved"
    
    return 0

}
