proc set_driver_menus { source_menu filter_menu integrate_menu output_menu other_menu other_menu_button} {

global driver_path
global source_drivers
global integrate_drivers
global filter_drivers
global output_drivers
global other_drivers


    # get a list of all files which are driver DSOs.
    pushd $driver_path
    set ndrivers [regsub -all "\.drv.so" [glob -nocomplain *drv.so] "" all_driver_dsos]
    popd
    
    # translate _ to <space>
    for {set i 0} {$i < [llength $all_driver_dsos]} {incr i} {
	lappend all_drivers [translit "_" " " [lindex $all_driver_dsos $i]]
    }

    # get the list of all source drivers
    set all_source_drivers [lmatch -glob $all_drivers "source *"]
    
    # remove source_rdm and source_collector, the drivers used only in the real time system
    set rt_source_drivers [lmatch -regexp $all_source_drivers "source (rdm|collector)"]
    set source_drivers [lindex [intersect3 $all_source_drivers $rt_source_drivers] 0]
    
    # get the other driver types
    set integrate_drivers [lmatch -glob $all_drivers "integrate *"]
    set filter_drivers [lmatch -glob $all_drivers "filter *"]
    set output_drivers [lmatch -glob $all_drivers "output *"]
    
    # get the remaining unclassified drivers
    set other_drivers [lindex [intersect3 $all_drivers $all_source_drivers] 0]
    set other_drivers [lindex [intersect3 $other_drivers $integrate_drivers] 0]
    set other_drivers [lindex [intersect3 $other_drivers $filter_drivers] 0]
    set other_drivers [lindex [intersect3 $other_drivers $output_drivers] 0]


    $source_menu delete 0 99999

    foreach source $source_drivers {
        $source_menu add command  -label $source -command "add_source_driver \"$source\""
    }

    foreach driver $filter_drivers {
        $filter_menu add command  -label $driver -command "add_driver \"$driver\""
    }
    foreach driver $integrate_drivers {
        $integrate_menu add command  -label $driver -command "add_driver \"$driver\""
    }
    foreach driver $output_drivers {
        $output_menu add command  -label $driver -command "add_driver \"$driver\""
    }
    if { [llength $other_drivers] > 0 } {
	$other_menu_button configure -state normal
	foreach driver $other_drivers {
            $other_menu add command  -label $driver -command "add_driver \"$driver\""
	}
    }
}
