#! /bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

# interface generated by SpecTcl version 1.1 from /ESRsoftware/PostIntegration/develop/Utilities/StrategyEditor/source_eiscat_dtst.ui
#   root     is the parent window for this user interface

proc source_eiscat_dtst_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 3 \
		-relief ridge

	frame $base.frame#3 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#4 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#5 \
		-borderwidth 2

	frame $base.frame#6 \
		-borderwidth 2 \
		-relief raised

	label $base.label#1 \
		-text Directory

	entry $base.entry#1 \
		-textvariable "driver_tmp($root.dir)"

	button $base.button#1 \
		-command "set driver_tmp($root.dir) \[file dirname \[tk_getOpenFile -title \"Select a file in the source directory\"\]\]" \
		-text Browse...

	label $base.start_label \
		-text {start time}

	entry $base.start_entry \
		-textvariable "driver_tmp($root.start)"

	checkbutton $base.checkbutton#3 \
		-text Tromso \
		-variable "driver_tmp($root.t)"

	checkbutton $base.checkbutton#4 \
		-text Kiruna \
		-variable "driver_tmp($root.k)"

	checkbutton $base.checkbutton#5 \
		-text Sodankyla \
		-variable "driver_tmp($root.s)"

	checkbutton $base.checkbutton#6 \
		-text VHF \
		-variable "driver_tmp($root.v)"

	button $base.button#2 \
		-command "source_eiscat_dtst_ok $root" \
		-text OK

	button $base.button#3 \
		-command "source_eiscat_dtst_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#3 -in $base.frame#1	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#4 -in $base.frame#1	-row 3 -column 1  \
		-ipady 2 \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 7 -column 1  \
		-sticky ew
	grid $base.frame#6 -in $base.frame#1	-row 5 -column 1  \
		-sticky ew
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1  \
		-sticky w
	grid $base.entry#1 -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.button#1 -in $base.frame#3	-row 1 -column 3  \
		-sticky e
	grid $base.start_label -in $base.frame#4	-row 1 -column 1  \
		-sticky e
	grid $base.start_entry -in $base.frame#4	-row 1 -column 2  \
		-sticky ew
	grid $base.checkbutton#3 -in $base.frame#6	-row 1 -column 1 
	grid $base.checkbutton#4 -in $base.frame#6	-row 1 -column 2 
	grid $base.checkbutton#5 -in $base.frame#6	-row 1 -column 3 
	grid $base.checkbutton#6 -in $base.frame#6	-row 1 -column 4 
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#6 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 2 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 3 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 4 -weight 0 -minsize 30

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30
	grid columnconfigure $base.frame#3 3 -weight 0 -minsize 30

	grid rowconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 2 -weight 1 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 1 -minsize 2
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 4 -weight 0 -minsize 2
	grid rowconfigure $base.frame#1 5 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 6 -weight 1 -minsize 20
	grid rowconfigure $base.frame#1 7 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc source_eiscat_dtst_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc source_eiscat_dtst_save { root file } {

global driver_data

    if { $driver_data(${root}.start) != "" } {
	if { [catch {clock scan $driver_data(${root}.start)} error] } {
	    error_message "$error\nfor \"source eiscat dtst\""
	    return 1
	}
    }
    
    if { $driver_data(${root}.dir) == "" } {
	error_message "No directory selected for \"source eiscat dtst\""
	return 1
    }

    puts $file "source eiscat dtst {"
    puts $file "    directory $driver_data(${root}.dir);"
    if { $driver_data(${root}.start) != "" }  {
	puts $file "    start $driver_data(${root}.start);"
    }
    if { $driver_data(${root}.t) || \
	    $driver_data(${root}.k) || $driver_data(${root}.s) || \
	    $driver_data(${root}.v) } {
	puts -nonewline $file "site"
	if { $driver_data(${root}.t) } { puts -nonewline $file " Tromso" }
	if { $driver_data(${root}.k) } { puts -nonewline $file " Kiruna" }
	if { $driver_data(${root}.s) } { puts -nonewline $file " Sodankyla" }
	if { $driver_data(${root}.v) } { puts -nonewline $file " VHF" }
	puts $file ";"
    }
    puts $file "}"
    
    return 0
}

proc source_eiscat_dtst_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.start) != "" } {
	if { [catch {clock scan $driver_tmp(${root}.start)} error] } {
	    error_message $error
	    return
	}
    }
    
    if { $driver_tmp(${root}.dir) == "" } {
	error_message "No directory selected"
	return
    }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_source_needs_save 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc source_eiscat_dtst_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)





# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if [info exists embed_args] {
	# we are running in the plugin
	source_eiscat_dtst_ui .
    } else {
	# we are running in stand-alone mode
	if {$argv0 == [info script]} {
	    wm title . "Testing source_eiscat_dtst_ui"
	    source_eiscat_dtst_ui .
	}
    }
}
