# interface generated by SpecTcl version 1.0 from /esrsw/uk/src/pi/Utilities/StrategyEditor/source_eiscat_matfile.ui
#   root     is the parent window for this user interface

proc source_eiscat_matfile_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 3 \
		-relief ridge

	frame $base.frame#5 \
		-borderwidth 2

	frame $base.frame#3 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#4 \
		-borderwidth 2 \
		-relief raised

	label $base.label#1 \
		-text Directory

	entry $base.entry#1 \
		-textvariable "driver_tmp($root.dir)"

	button $base.button#1 \
		-command "set driver_tmp($root.directory) \[file dirname \[tk_getOpenFile -title \"Select a file in the source directory\"\]\]" \
		-text Browse...

	checkbutton $base.checkbutton#1 \
		-command "source_eiscat_matfile_select_filelist $root" \
		-text filelist \
		-variable "driver_tmp($root.filelist)"

	label $base.start_label \
		-text {start time}

	entry $base.start_entry \
		-textvariable "driver_tmp($root.start)"
	catch {
		$base.start_entry configure \
			-font {-*-interface user-Medium-R-Normal-*-*-120-*-*-*-*-*-*}
	}

	button $base.button#2 \
		-command "source_eiscat_matfile_ok $root" \
		-text OK

	button $base.button#3 \
		-command "source_eiscat_matfile_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 5 -column 1  \
		-sticky ew
	grid $base.frame#3 -in $base.frame#1	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#4 -in $base.frame#1	-row 3 -column 1  \
		-ipady 2 \
		-sticky nesw
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1  \
		-sticky w
	grid $base.entry#1 -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.button#1 -in $base.frame#3	-row 1 -column 3  \
		-sticky e
	grid $base.checkbutton#1 -in $base.frame#4	-row 1 -column 1 
	grid $base.start_label -in $base.frame#4	-row 1 -column 2  \
		-sticky e
	grid $base.start_entry -in $base.frame#4	-row 1 -column 3  \
		-sticky ew
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30
	grid columnconfigure $base.frame#3 3 -weight 0 -minsize 30

	grid rowconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 2 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 3 -weight 1 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 1 -minsize 2
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 4 -weight 1 -minsize 3
	grid rowconfigure $base.frame#1 5 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    set driver_tmp(${root}.start_entry) $base.start_entry
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
    source_eiscat_matfile_select_filelist $root
}

proc source_eiscat_matfile_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
    
}

proc source_eiscat_matfile_save { root file } {

global driver_data

    if { ! $driver_data(${root}.filelist) } {
	if { [catch {clock scan $driver_data(${root}.start)} error] } {
	    error_message "$error\nfor \"source eiscat matfile\""
	    return 1
	}
    }
    
    if { $driver_data(${root}.dir) == "" } {
	error_message "No directory selected for \"source eiscat matfile\""
	return 1
    }

    puts $file "source eiscat matfile {"
    puts $file "    directory $driver_data(${root}.dir);"
    if { $driver_data(${root}.filelist) } {
	puts $file "    filelist;"
    } elseif { $driver_data(${root}.start) != "" }  {
	puts $file "    start $driver_data(${root}.start);"
    }
    puts $file "}"
    
    return 0
}

proc source_eiscat_matfile_select_filelist { root } {

global driver_tmp

    if { $driver_tmp(${root}.filelist) } {
	$driver_tmp(${root}.start_entry) configure -state disabled
    } else {
	$driver_tmp(${root}.start_entry) configure -state normal
    }
    
}

proc source_eiscat_matfile_ok { root } {

global driver_data
global driver_tmp

    if { ! $driver_tmp(${root}.filelist) } {
	if { [catch {clock scan $driver_tmp(${root}.start)} error] } {
	    error_message $error
	    return
	}
    }
    
    if { $driver_tmp(${root}.dir) == "" } {
	error_message "No directory selected"
	return
    }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_source_needs_save 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc source_eiscat_matfile_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)



# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing source_eiscat_matfile"
	source_eiscat_matfile_ui .
    }
}
