# interface generated by SpecTcl version 1.0 from /esrsw/uk/src/pi/Utilities/StrategyEditor/source_eiscat_simulated.ui
#   root     is the parent window for this user interface

proc source_eiscat_simulated_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 3 \
		-relief ridge

	frame $base.frame#3 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#5 \
		-borderwidth 2

	frame $base.frame#4 \
		-borderwidth 2 \
		-relief raised

	label $base.label#1 \
		-text File

	entry $base.entry#1 \
		-textvariable "driver_tmp($root.file)"

	button $base.button#1 \
		-command "set driver_tmp($root.file) \[tk_getOpenFile -title \"Select the source file\"\]" \
		-text Browse...

	label $base.start_label \
		-text dataio

	entry $base.dataio_entry \
		-textvariable "driver_tmp($root.dataio)" \
		-width 6
	catch {
		$base.dataio_entry configure \
			-font {-*-interface user-Medium-R-Normal-*-*-120-*-*-*-*-*-*}
	}

	button $base.button#2 \
		-command "source_eiscat_simulated_ok $root" \
		-text OK

	button $base.button#3 \
		-command "source_eiscat_simulated_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#3 -in $base.frame#1	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 6 -column 1  \
		-sticky ew
	grid $base.frame#4 -in $base.frame#1	-row 3 -column 1  \
		-ipady 2 \
		-sticky nesw
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1  \
		-sticky w
	grid $base.entry#1 -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.button#1 -in $base.frame#3	-row 1 -column 3  \
		-sticky e
	grid $base.start_label -in $base.frame#4	-row 1 -column 1  \
		-sticky e
	grid $base.dataio_entry -in $base.frame#4	-row 1 -column 2  \
		-sticky w
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30
	grid columnconfigure $base.frame#3 3 -weight 0 -minsize 30

	grid rowconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#4 2 -weight 1 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 1 -minsize 2
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 4 -weight 0 -minsize 2
	grid rowconfigure $base.frame#1 5 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 6 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc source_eiscat_simulated_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc source_eiscat_simulated_save { root file } {

global driver_data

    if { $driver_data(${root}.file) == "" } {
	error_message "No file selected for \"source eiscat simulated\""
	return 1
    }
    if { $driver_data(${root}.dataio) == "" } {
	error_message "No dataio for \"source eiscat simulated\""
	return 1
    }

    puts $file "source eiscat simulated {"
    puts $file "    file $driver_data(${root}.file);"
    puts $file "    dataio $driver_data(${root}.dataio);"
    puts $file "}"
    
    return 0
}

proc source_eiscat_simulated_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.file) == "" } {
	error_message "No file selected"
	return
    }
    if { $driver_tmp(${root}.dataio) == "" } {
	error_message "No dataio set"
	return
    }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_source_needs_save 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc source_eiscat_simulated_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)



# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing source_eiscat_simulated"
	source_eiscat_simulated_ui .
    }
}
