# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/develop/Utilities/StrategyEditor/source_real_time.ui
#   root     is the parent window for this user interface

proc source_real_time_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-background #d9d9d9 \
		-borderwidth 3 \
		-highlightbackground #d9d9d9 \
		-relief ridge

	frame $base.frame#5 \
		-background #d9d9d9 \
		-borderwidth 2 \
		-highlightbackground #d9d9d9

	frame $base.frame#3 \
		-background #d9d9d9 \
		-borderwidth 2 \
		-highlightbackground #d9d9d9 \
		-relief raised

	label $base.label#1 \
		-background #d9d9d9 \
		-foreground Black \
		-highlightbackground #d9d9d9 \
		-text Host
	catch {
		$base.label#1 configure \
			-font -*-Helvetica-Bold-R-Normal-*-*-120-*-*-*-*-*-*
	}

	entry $base.entry#1 \
		-background #d9d9d9 \
		-foreground Black \
		-highlightbackground #d9d9d9 \
		-textvariable "driver_tmp($root.server)"
	catch {
		$base.entry#1 configure \
			-font -*-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*
	}

	button $base.button#2 \
		-background #d9d9d9 \
		-command "source_real_time_ok $root" \
		-foreground Black \
		-highlightbackground #d9d9d9 \
		-padx 9 \
		-pady 3 \
		-text OK
	catch {
		$base.button#2 configure \
			-font -*-Helvetica-Bold-R-Normal-*-*-120-*-*-*-*-*-*
	}

	button $base.button#3 \
		-background #d9d9d9 \
		-command "source_real_time_cancel $root" \
		-foreground Black \
		-highlightbackground #d9d9d9 \
		-padx 9 \
		-pady 3 \
		-text Cancel
	catch {
		$base.button#3 configure \
			-font -*-Helvetica-Bold-R-Normal-*-*-120-*-*-*-*-*-*
	}


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 4 -column 1  \
		-sticky ew
	grid $base.frame#3 -in $base.frame#1	-row 1 -column 1  \
		-sticky nesw
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1  \
		-sticky w
	grid $base.entry#1 -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 1 -minsize 2
	grid rowconfigure $base.frame#1 3 -weight 1 -minsize 3
	grid rowconfigure $base.frame#1 4 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    set driver_tmp(start_entry) $root.start_entry
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc source_real_time_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc source_real_time_save { root file } {

global driver_data

    if { $driver_data(${root}.server) == "" } {
	error_message "No server selected for \"source real time\""
	return 1
    }
    
    puts $file "source real time {"
    puts $file "    server $driver_data(${root}.server);"
    puts $file "}"
    
    return 0
}

proc source_real_time_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.server) == "" } {
	error_message "No server selected"
	return 
    }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_source_needs_save 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc source_real_time_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)


# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing source_real_time"
	source_real_time_ui .
    }
}
