# interface generated by SpecTcl version 1.0 from /ESRsoftware/PostIntegration/develop2/Utilities/StrategyEditor/source_rt_data.ui
#   root     is the parent window for this user interface

proc source_rt_data_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 3 \
		-relief ridge

	frame $base.frame#3 \
		-borderwidth 2 \
		-relief raised

	frame $base.frame#5 \
		-borderwidth 2

	frame $base.frame#6 \
		-borderwidth 2 \
		-relief raised

	label $base.label#1 \
		-text Host

	entry $base.host_entry \
		-textvariable "driver_tmp($root.server)"

	label $base.label#2 \
		-text {start time}

	entry $base.start_entry \
		-textvariable "driver_tmp($root.start)"

	button $base.button#2 \
		-command "source_rt_data_ok $root" \
		-text OK

	button $base.button#3 \
		-command "source_rt_data_cancel $root" \
		-text Cancel


	# Geometry management

	grid $base.frame#1 -in $root	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#3 -in $base.frame#1	-row 1 -column 1  \
		-sticky nesw
	grid $base.frame#5 -in $base.frame#1	-row 6 -column 1  \
		-sticky ew
	grid $base.frame#6 -in $base.frame#1	-row 3 -column 1  \
		-sticky ew
	grid $base.label#1 -in $base.frame#3	-row 1 -column 1  \
		-sticky w
	grid $base.host_entry -in $base.frame#3	-row 1 -column 2  \
		-sticky ew
	grid $base.label#2 -in $base.frame#6	-row 1 -column 1 
	grid $base.start_entry -in $base.frame#6	-row 1 -column 2  \
		-sticky ew
	grid $base.button#2 -in $base.frame#5	-row 1 -column 1 
	grid $base.button#3 -in $base.frame#5	-row 1 -column 2 

	# Resize behavior management

	grid rowconfigure $base.frame#6 1 -weight 1 -minsize 30
	grid columnconfigure $base.frame#6 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#6 2 -weight 1 -minsize 30

	grid rowconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#3 2 -weight 1 -minsize 30

	grid rowconfigure $root 1 -weight 1 -minsize 30
	grid columnconfigure $root 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 0 -minsize 4
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 4 -weight 1 -minsize 2
	grid rowconfigure $base.frame#1 5 -weight 1 -minsize 3
	grid rowconfigure $base.frame#1 6 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 1 -minsize 30

	grid rowconfigure $base.frame#5 1 -weight 0 -minsize 30
	grid columnconfigure $base.frame#5 1 -weight 1 -minsize 67
	grid columnconfigure $base.frame#5 2 -weight 1 -minsize 30
# additional interface code
global driver_data
global driver_tmp
    set driver_tmp(${root}.root) $root
    foreach name [array names driver_tmp ${root}.*] {
	set driver_data($name) $driver_tmp($name)
    }
}

proc source_rt_data_set_values { root values } {

global driver_data
global driver_tmp

    foreach value $values {
	set var [lindex $value 0]
	set val [join [lrange $value 1 end]]
	set driver_tmp(${root}.${var}) $val
	set driver_data(${root}.${var}) $val
    }
}

proc source_rt_data_save { root file } {

global driver_data

    if { $driver_data(${root}.server) == "" } {
	error_message "No server selected for \"source rt data\""
	return 1
    }
    
    if { $driver_data(${root}.start) != "" } {
	if { [catch {clock scan $driver_data(${root}.start)} error] } {
	    error_message "$error\nfor \"source rt data\""
	    return 1
	}
    }
    
    puts $file "source rt data {"
    puts $file "    server $driver_data(${root}.server);"
    if { $driver_data(${root}.start) != "" }  {
	puts $file "    start $driver_data(${root}.start);"
    }
    puts $file "}"
    
    return 0
}

proc source_rt_data_ok { root } {

global driver_data
global driver_tmp

    if { $driver_tmp(${root}.server) == "" } {
	error_message "No server selected"
	return
    }
    
    if { $driver_tmp(${root}.start) != "" } {
	if { [catch {clock scan $driver_tmp(${root}.start)} error] } {
	    error_message $error
	    return
	}
    }
    
    foreach name [array names driver_tmp ${root}.*] {
	if { $driver_data($name) != $driver_tmp($name) } {
	    set driver_data($name) $driver_tmp($name)
	    set_source_needs_save 1
	}
    }
    
    destroy $driver_data(${root}.root)
}

proc source_rt_data_cancel { root } {

global driver_data
global driver_tmp

    foreach name [array names driver_data ${root}.*] {
	set driver_tmp($name) $driver_data($name)
    }
    
    destroy $driver_data(${root}.root)


# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . "Testing source_rt_data"
	source_rt_data_ui .
    }
}
