proc test_strategy {  } {

    set sfile /tmp/.[pid].sdef
    if { [save_source_file $sfile 0] != 0 } {
	status_message "Failure during test"
	if { [file exists $sfile] } {
	    exec rm $sfile
	}
	return 1
    }
    
    set ifile /tmp/.[pid].idef
    if { [save_strategy_file $ifile 0] != 0 } {
	status_message "Failure during test"
	if { [file exists $ifile] } {
	    exec rm $ifile
	}
	return 1
    }
    
    set status [catch "exec test_strategy_text -s $sfile -i $ifile" output]
    if { $status != 0 } {
	status_message "Failure during strategy parse - status $status"
	error_message "Strategy failed to parse correctly"
	error_message "$output"
    } else {
	status_message "Test ok"
    }
    if { [file exists $sfile] } {
	exec rm $sfile
    }
    if { [file exists $ifile] } {
	exec rm $ifile
    }
    
    return $status
}
